// QANav Report Tracker Copyright 2004 Ronald D. Grindle

import java.io.IOException;
import java.io.PrintWriter;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import RTtools.UserMailTool;

import com.qanavigation.Basics.Rslt;
import com.qanavigation.Basics.RsltStatVal;
import com.qanavigation.Basics.RsltString;
import com.qanavigation.Basics.SFormatter;
import com.qanavigation.DBacc.QuerySet;
import com.qanavigation.DBacc.SQLRslt;
import com.qanavigation.QNservices.QNDBacc2;
import com.qanavigation.QNservices.QNRscBundle;
import com.qanavigation.QNservices.SrvltReqTools;

/**
* Service to do different kind updates the users DB
*/
public class AdmUser extends HttpServlet {

	static final long serialVersionUID = 61940003;
	
	//---------------------------------------------
	protected void service(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
		super.service( request, response );
	}

	//---------------------------------------------
	public void doGet(HttpServletRequest request, HttpServletResponse response) throws IOException, ServletException {
		handleReq( request, response );
	}

	//---------------------------------------------
	public void doPost(HttpServletRequest request, HttpServletResponse response) throws IOException, ServletException {
		handleReq( request, response );
	}

	//---------------------------------------------
	public void handleReq(HttpServletRequest request, HttpServletResponse response) throws IOException {

		boolean notHandled = true;
		boolean isAdm = false;

		String sender;
		String senderClear;
		
		response.setContentType("text/html");

		PrintWriter out = response.getWriter();

		RsltString res = new RsltString( true );

		SrvltReqTools sTools = new SrvltReqTools( this, request );
		
		if( !res.checkRslt( sTools ) ) {
			
			res.addRsltAddInfo( "Init of SrvltReqTools failed." );
		}

		QNDBacc2 dBAcc = new QNDBacc2();
		
		if( !res.checkRslt( dBAcc ) ) {
			
			res.addRsltAddInfo( "Init of QNDBacc failed." );
		}
		
		res.checkRslt( dBAcc );
		
		isAdm = ( request.isUserInRole( "adm" ) || request.isUserInRole( "sp" ) || request.isUserInRole( "dpl" ) );

		if( res.isOK() ) {
			
			if( notHandled ) {

				if( sTools.checkVal( "QNA", "AddBrnch" ) ) {
					
					notHandled = false;
					
					res = AddBrnch( sTools, dBAcc, isAdm );
				}
			}			
			
			if( notHandled ) {

				if( sTools.checkVal( "QNA", "AddU" ) ) {
					
					notHandled = false;
					
					res = AddU( sTools, dBAcc, isAdm );
				}
			}	
			
			if( notHandled ) {

				if( sTools.checkVal( "QNA", "AddR" ) ) {
					
					notHandled = false;
					
					res = AddR( sTools, dBAcc, isAdm );
				}
			}				
			
			if( notHandled ) {

				if( sTools.checkVal( "QNA", "AddP" ) ) {
					
					notHandled = false;
					
					res = AddP( sTools, dBAcc, isAdm );
				}
			}				
			
			if( notHandled ) {

				if( sTools.checkVal( "QNA", "AddGrp" ) ) {
					
					notHandled = false;
					
					res = AddGrp( sTools, dBAcc, isAdm );
				}
			}				
			
			if( notHandled ) {

				if( sTools.checkVal( "QNA", "AddProd" ) ) {
					
					notHandled = false;
					
					res = AddProd( sTools, dBAcc, isAdm );
				}
			}				
			
			if( notHandled ) {

				if( sTools.checkVal( "QNA", "AddRel" ) ) {
					
					notHandled = false;
					
					res = AddRel( sTools, dBAcc, isAdm );
				}
			}				
						
			if( notHandled ) {

				if( sTools.checkVal( "QNA", "AddSys" ) ) {
					
					notHandled = false;
					
					res = AddSys( sTools, dBAcc, isAdm );
				}
			}	
			
			
			if( notHandled ) {

				if( sTools.checkVal( "QNA", "DelBrnch" ) ) {
					
					notHandled = false;
					
					res = DelBrnch( sTools, dBAcc, isAdm );
				}
			}	
						
			if( notHandled ) {

				if( sTools.checkVal( "QNA", "DelU" ) ) {
					
					notHandled = false;
					
					res = DelU( sTools, dBAcc, isAdm );
				}
			}							
			
			if( notHandled ) {

				if( sTools.checkVal( "QNA", "DelR" ) ) {
					
					notHandled = false;
					
					res = DelR( sTools, dBAcc, isAdm );
				}
			}				

			
			if( notHandled ) {

				if( sTools.checkVal( "QNA", "DelP" ) ) {
					
					notHandled = false;
					
					res = DelP( sTools, dBAcc, isAdm );
				}
			}				
			
			if( notHandled ) {

				if( sTools.checkVal( "QNA", "DelGrp" ) ) {
					
					notHandled = false;
					
					res = DelGrp( sTools, dBAcc, isAdm );
				}
			}				
			
			if( notHandled ) {

				if( sTools.checkVal( "QNA", "DelProd" ) ) {
					
					notHandled = false;
					
					res = DelProd( sTools, dBAcc, isAdm );
				}
			}		
			
			if( notHandled ) {

				if( sTools.checkVal( "QNA", "DelRel" ) ) {
					
					notHandled = false;
					
					res = DelRel( sTools, dBAcc, isAdm );
				}
			}
			
			if( notHandled ) {

				if( sTools.checkVal( "QNA", "DelSys" ) ) {
					
					notHandled = false;
					
					res = DelSys( sTools, dBAcc, isAdm );
				}
			}	
			
			if( notHandled ) {

				if( sTools.checkVal( "QNA", "SetPW" ) ) {
					
					notHandled = false;
					
					res = SetPW( sTools, dBAcc, isAdm );
				}
			}				
						
			if( notHandled ) {

				if( sTools.checkVal( "QNA", "SetGrp" ) ) {
					
					notHandled = false;
					
					res = SetGrp( sTools, dBAcc, isAdm );
				}
			}			
						
			if( notHandled ) {

				if( sTools.checkVal( "QNA", "SetMail" ) ) {
					
					notHandled = false;
					
					res = SetMail( sTools, dBAcc, isAdm );
				}
			}

			// unknown request -----------------------------------------
			if( notHandled ) {

				res.setInError( "Wrong QNA." );
			}
		}

		if( res.isOK() ) {

			out.println( "<p>" + res.getString() + "</p>" );
		}
		
		if( res.isInStat( RsltStatVal.isDupli )  ) {
			
			out.println( "<p>" + res.getRsltFinalMsg() + "</p>" );
			out.println( "<p>The entry already exists.</p>" );
			
			res.setOK();
		}
		
		if( res.notOK() ) {
			
/*
int i, x;
out.println( "<p>Status res: " + RsltStatVal.label[ res.getRsltStatVal() ] + "</p>" );
ArrayList addInfo;
addInfo = res.getRsltAddInfo();
x = addInfo.size();

for( i = 0; i < x; ++i ) {

	out.println( "<br>" + (String)addInfo.get( i ) );
}			
*/
			QNRscBundle resBndl = new QNRscBundle( "QNLabels", sTools.m_Req.getLocale() );
			
			UserMailTool mt = new UserMailTool( dBAcc.m_DB );
			String mMsg = "An error occured: " + res.getRsltFinalMsg();
			String subj = "QANav error at " + request.getRequestURL();
			
			sender = resBndl.getString( "valSenderMail" );	
			senderClear = resBndl.getString( "valSenderClear" );
			
			mt.mailToAdm( subj, mMsg, mMsg, sender, senderClear );
			
			String errMsg1 = "Transaction is in error.";
			String errMsg2 = SFormatter.format( "Error reason: {0}", res.getRsltFinalMsg() );
			String errMsg3 = "The administrator was notified.";

			SrvltReqTools.logErr( this, request, res );

/*			
			ServletContext sc = getServletContext();
			String url = "/ErrMsg.jsp?";

			url += "Msg1=" + SrvltReqTools.encodeReqStr( errMsg1  );
			url += "&Msg2=" + SrvltReqTools.encodeReqStr( errMsg2  );
			url += "&Msg3=" + SrvltReqTools.encodeReqStr( errMsg3  );

			RequestDispatcher rd = sc.getRequestDispatcher( url );
			
			if( rd != null ) {
				
				rd.forward( request, response );
			}
			else {
*/
				out.println( "<p>" + errMsg1 + "</p>" );			
				out.println( "<p>" + errMsg2 + "</p>" );
				out.println( "<p>" + errMsg3 + "</p>" );
//			}
		}
		
		dBAcc.close();
	}
	
	// -----------------------------
	private RsltString AddBrnch( SrvltReqTools sTools, QNDBacc2 dBAcc, boolean isAdm ) {		
		
		RsltString res = new RsltString( true );

		String val;
		String msg1;
		
		SQLRslt aRes;

		if( !( isAdm ) ) {

			res.setInError( "You are not authorized to execute this task." );
		}

		RsltString rVal;

		rVal = sTools.getVal( "Brnch" );	
		
		val = cleanStr( rVal.getString() );
		
		if( !res.checkRslt( rVal ) ) {
			
			res.addRsltAddInfo( "Retrieving the param failed." );
		}
		else {				

			QuerySet qSet = new QuerySet( 2, "DataLst" );

			qSet.addQCol( "Name", "DevBranch", false );
			qSet.addQCol( "Val", val, true );
			
			aRes = dBAcc.m_DB.insert( qSet );
		
			if( !res.checkRslt( aRes ) ) {
				
				res.addRsltAddInfo( "Insert in 'DataLst' failed." );
			}					
		}

		dBAcc.m_DB.doCommit( res.isOK() );

		msg1 = "Branch '" + val + "' added.";
		
		if( res.notOK() ) {
			
			res.addRsltAddInfo( "'Add Branch' failed." );
		}
		else {
			
			res.setString( msg1 );
		}
		
		return res;		
	}	
	
	// -----------------------------
	private RsltString AddGrp( SrvltReqTools sTools, QNDBacc2 dBAcc, boolean isAdm ) {		
		
		RsltString res = new RsltString( true );

		String group;
		String msg1;
		
		SQLRslt aRes;

		if( !( isAdm ) ) {

			res.setInError( "You are not authorized to execute this task." );
		}

		RsltString grp;

		grp = sTools.getVal( "Grp" );
						
		group = cleanStr( grp.getString() );				
		
		if( !res.checkRslt( grp ) ) {
			
			res.addRsltAddInfo( "Retrieving the param failed." );
		}
		else {

			QuerySet qSet = new QuerySet( 1, "UGroups" );

			qSet.addQCol( "Name", group, false );
			
			aRes = dBAcc.m_DB.insert( qSet );
		
			if( !res.checkRslt( aRes ) ) {
				
				res.addRsltAddInfo( "Insert in 'UserRoles' failed." );
			}					
		}

		dBAcc.m_DB.doCommit( res.isOK() );

		msg1 = "Group '" + group + "' added to Groups.";
		
		if( res.notOK() ) {
			
			res.addRsltAddInfo( "'Add Group' failed." );
		}
		else {
			
			res.setString( msg1 );
		}
		
		return res;		
	}
	
	
	// -----------------------------
	private RsltString AddP( SrvltReqTools sTools, QNDBacc2 dBAcc, boolean isAdm ) {		
		
		RsltString res = new RsltString( true );

		RsltString User;
		String msg1;
		
		SQLRslt aRes;	

		if( !( isAdm ) ) {

			res.setInError( "You are not authorized to execute this task." );
		}
		
		RsltString Prod = new RsltString();
		RsltString Rel = new RsltString();
		
		User = sTools.getVal( "User" );
		
//res.addRsltAddInfo( "User " + User.getString() );				
		if( res.checkRslt( User ) ) {
		
			Prod = sTools.getVal( "Prod" );
			Rel = sTools.getVal( "Rel" );
			
//res.addRsltAddInfo( "Prod " + Prod.getString() );							
		}

		if( !res.checkRslt( Prod ) ) {
			
			res.addRsltAddInfo( "Retrieving the param failed." );
		}
		else {

			QuerySet qSet = new QuerySet( 3, "UserProds" );

			qSet.addQCol( "Name", User.getString(), true );
			qSet.addQCol( "Prod", Prod.getString(), false );
			qSet.addQCol( "Rel", Rel.getString(), false );
			
			aRes = dBAcc.m_DB.insert( qSet );
		
			if( !res.checkRslt( aRes ) ) {
				
				res.addRsltAddInfo( "Insert in 'UserProds' failed." );
			}
		}

		dBAcc.m_DB.doCommit( res.isOK() );

		msg1 = "Product '" + Prod.getString() + "' added to user '" + User.getString() + "'.";
		
		if( res.notOK() ) {
			
			res.addRsltAddInfo( "'Add Product' failed." );
		}
		else {
			
			res.setString( msg1 );
		}
		
		return res;		
	}	
	
	// -----------------------------
	private RsltString AddProd( SrvltReqTools sTools, QNDBacc2 dBAcc, boolean isAdm ) {		
		
		RsltString res = new RsltString( true );

		String msg1;
		
		SQLRslt aRes;		

		if( !( isAdm ) ) {

			res.setInError( "You are not authorized to execute this task." );
		}
		else {

			RsltString rPrd;
			String prod;

			rPrd = sTools.getVal( "Prod" );
							
			prod = cleanStr( rPrd.getString() );				
			
			if( !res.checkRslt( rPrd ) ) {
				
				res.addRsltAddInfo( "Retrieving the param failed." );
			}
			else {

				QuerySet qSet = new QuerySet( 1, "Prods" );

				qSet.addQCol( "Name", prod, true );
				
				aRes = dBAcc.m_DB.insert( qSet );
			
				if( !res.checkRslt( aRes ) ) {
					
					res.addRsltAddInfo( "Insert in 'Prods' failed." );
				}					
			}

			dBAcc.m_DB.doCommit( res.isOK() );

			msg1 = "Product '" + prod + "' added to Products.";
			
			if( res.notOK() ) {
				
				res.addRsltAddInfo( "'Add Product' failed." );
			}
			else {
				
				res.setString( msg1 );
			}		
		}
		return res;
	}	
	
	// -----------------------------
	private RsltString AddR( SrvltReqTools sTools, QNDBacc2 dBAcc, boolean isAdm ) {		
		
		RsltString res = new RsltString( true );

		RsltString User;

		String msg1;
		
		SQLRslt aRes;
		
		if( !( isAdm ) ) {

			res.setInError( "You are not authorized to execute this task." );
		}

		RsltString Role = new RsltString();

		User = sTools.getVal( "User" );
		
		if( res.checkRslt( User ) ) {
		
			Role = sTools.getVal( "Role" );
		}
		
		if( !res.checkRslt( Role ) ) {
			
			res.addRsltAddInfo( "Retrieving the param failed." );
		}
		else {

			QuerySet qSet = new QuerySet( 2, "UserRoles" );

			qSet.addQCol( "Name", User.getString(), true );
			qSet.addQCol( "Role", Role.getString(), false );
			
			aRes = dBAcc.m_DB.insert( qSet );
		
			if( !res.checkRslt( aRes ) ) {
				
				res.addRsltAddInfo( "Insert in 'UserRoles' failed." );
			}					
		}

		dBAcc.m_DB.doCommit( res.isOK() );

		msg1 = "Role '" + Role.getString() + "' added to user '" + User.getString() + "'.";
		
		if( res.notOK() ) {
			
			res.addRsltAddInfo( "'Add Role' failed." );
		}
		else {
			
			res.setString( msg1 );
		}
		
		return res;
	}
	
	// -----------------------------
	private RsltString AddRel( SrvltReqTools sTools, QNDBacc2 dBAcc, boolean isAdm ) {		

		RsltString res = new RsltString( true );

		String msg1;
		
		SQLRslt aRes;		

		if( !( isAdm ) ) {

			res.setInError( "You are not authorized to execute this task." );
		}

		RsltString rPrd;
		RsltString rRel;				
		String prod;
		String rel;


		rPrd = sTools.getVal( "Prod" );
		prod = cleanStr( rPrd.getString() );	
		rRel = sTools.getVal( "Rel" );
		rel = cleanStr( rRel.getString() );	
		
		if( !res.checkRslt( rRel ) ) {
			
			res.addRsltAddInfo( "Retrieving the param failed." );
		}
		else {

			QuerySet qSet = new QuerySet( 2, "ProdRels" );

			qSet.addQCol( "Prod", prod, false );
			qSet.addQCol( "Rel", rel, false );					
			
			aRes = dBAcc.m_DB.insert( qSet );
		
			if( !res.checkRslt( aRes ) ) {
				
				res.addRsltAddInfo( "Insert in 'ProdRels' failed." );
			}					
		}

		dBAcc.m_DB.doCommit( res.isOK() );

		msg1 = "Release '" + rel + "' added to Releases.";
		
		if( res.notOK() ) {
			
			res.addRsltAddInfo( "'Add Release' failed." );
		}
		else {
			
			res.setString( msg1 );
		}
		
		return res;
	}
	
	// -----------------------------
	private RsltString AddSys( SrvltReqTools sTools, QNDBacc2 dBAcc, boolean isAdm ) {		

		RsltString res = new RsltString( true );
		
		String msg1;
		
		SQLRslt aRes;

		if( !( isAdm ) ) {

			res.setInError( "You are not authorized to execute this task." );
		}

		RsltString rSys;
		String sys;

		rSys = sTools.getVal( "Sys" );
						
		sys = cleanStr( rSys.getString() );				
		
		if( !res.checkRslt( rSys ) ) {
			
			res.addRsltAddInfo( "Retrieving the param failed." );
		}
		else {

			QuerySet qSet = new QuerySet( 1, "Systems" );

			qSet.addQCol( "Name", sys, false );
			
			aRes = dBAcc.m_DB.insert( qSet );
		
			if( !res.checkRslt( aRes ) ) {
				
				res.addRsltAddInfo( "Insert in 'Systems' failed." );
			}					
		}

		dBAcc.m_DB.doCommit( res.isOK() );

		msg1 = "'" + sys + "' added to Systems.";
		
		if( res.notOK() ) {
			
			res.addRsltAddInfo( "'Add System' failed." );
		}
		else {
			
			res.setString( msg1 );
		}
		
		return res;
	}	
	
	// -----------------------------
	private RsltString AddU( SrvltReqTools sTools, QNDBacc2 dBAcc, boolean isAdm ) {		

		RsltString res = new RsltString( true );

		RsltString User;

		String group;
		String mail;
		String msg1;
		String sender;
		String senderClear;
		String user;
		
		SQLRslt aRes;		

		if( !(isAdm) ) {

			res.setInError( "You are not authorized to execute this task." );
		}

		RsltString PW = new RsltString();
		RsltString Mail = new RsltString();
		RsltString Role;
		RsltString Prod;
		RsltString Rel;
		String dig;
		
		QNRscBundle resBndl = new QNRscBundle( "QNLabels", sTools.m_Req.getLocale() );

		User = sTools.getVal( "User" );
		
		if( res.checkRslt( User ) ) {
			
			PW = sTools.getVal( "PW" );
		}
		
		if( res.checkRslt( PW ) ) {
			
			Mail = sTools.getVal( "Mail" );
		}
		
		user = User.getString();
		user = cleanStr( user );
		
		mail = Mail.getString();
		mail = cleanStr( mail );
		
		group = sTools.getStrVal( "UGroup" );
		group = cleanStr( group );					

		if( res.notOK() ) {
			
			res.addRsltAddInfo( "'Add User': Retrieving a parameter failed." );
		}
		else {
			
			dBAcc.m_DB.startTrans();

			QuerySet qSet = new QuerySet( 4, "Users" );

			dig = SFormatter.digestSHA( PW.getString() );				
			
			qSet.addQCol( "Name", user, true );
			qSet.addQCol( "PW", dig, false );
			qSet.addQCol( "Mail", mail, false );
			qSet.addQCol( "UGroup", group, false  );

			aRes = dBAcc.m_DB.insert( qSet );

			if( !res.checkRslt( aRes ) ) {
				
				res.addRsltAddInfo( "'Add User': Insert in 'Users' failed." );
			}
		}

		if( res.isOK() && sTools.hasVal( "Role" ) ) {

			Role = sTools.getVal( "Role" );

			QuerySet qSet = new QuerySet( 2, "UserRoles" );

			qSet.addQCol( "Name", user, false );
			qSet.addQCol( "Role", Role.getString(), true );
			
			aRes = dBAcc.m_DB.insert( qSet );

			if( !res.checkRslt( aRes ) ) {
				
				res.addRsltAddInfo( "'Add User': Insert in 'Role' failed." );
			}
		}

		if( res.isOK() && sTools.hasVal( "Prod" ) ) {

			Prod = sTools.getVal( "Prod" );
			
			if( Prod.getString().length() > 0 ) {

				Rel = sTools.getVal( "Rel" );

				QuerySet qSet = new QuerySet( 3, "UserProds" );

				qSet.addQCol( "Name", user, true );
				qSet.addQCol( "Prod", Prod.getString(), false );
				qSet.addQCol( "Rel", Rel.getString(), false );

				aRes = dBAcc.m_DB.insert( qSet );

				if( !res.checkRslt( aRes ) ) {

					res.addRsltAddInfo( "'Add User': Insert in 'Prod' failed." );
				}
			}
		}

		dBAcc.m_DB.doCommit( res.isOK() );

		msg1 = "User '" + user + "' added to user list.";

		if( res.isOK() && ( Mail.getString().length() > 0 ) ) {

			UserMailTool mt = new UserMailTool( dBAcc.m_DB );
			
			if( res.checkRslt( mt ) ) {
				
				Rslt mRes;

				String subj = SFormatter.decodeHTML( resBndl.getString( "msgNewUserQANav" ) );
				String theUrl = sTools.getUrl4AccMgmt();
				
				String hMsg = "<p>" + resBndl.getString( "msgDearUser" ) + "</p>";
				hMsg += "<p>" + resBndl.getString( "msgQANAdmHasNA" ) + "</p>";
				hMsg += "<p>";
				hMsg += SFormatter.format( resBndl.getString( "msgYourUID" ), user );
				hMsg += "</p>";
				hMsg += "<p>";
				hMsg += SFormatter.format( resBndl.getString( "msgYourPW" ), PW.getString() );
				hMsg += "</p>";
				hMsg += "<p>" + resBndl.getString( "msgPlsLogonTo" ) + "</p>";
				hMsg += "<p><a href=\"" + theUrl + "Admin/\">" + theUrl + "Admin/</a></p>";
				hMsg += "<p>" + resBndl.getString( "msgAndChgPWImi" ) + "</p>";
				hMsg += "<p>" + resBndl.getString( "msgToWorkQANav" ) + "</p>";
				hMsg += "<p><a href=\"" + theUrl + "\">" + theUrl + "</a></p>";								
				hMsg += "<p>" + resBndl.getString( "msgAutoMsg" ) + "</p>";		
				
				String tMsg = resBndl.getString( "msgDearUser" );
				tMsg += "\n" + resBndl.getString( "msgQANAdmHasNA" );
				tMsg += "\n" + SFormatter.format( resBndl.getString( "msgYourUID" ), user );
				tMsg += "\n" + SFormatter.format( resBndl.getString( "msgYourPW" ), PW.getString() );
				tMsg += "\n" + resBndl.getString( "msgPlsLogonTo" );
				tMsg += "\n" + theUrl + "Admin/";
				tMsg += "\n" + resBndl.getString( "msgAndChgPWImi" );
				tMsg += "\n" + resBndl.getString( "msgToWorkQANav" );
				tMsg += "\n" + theUrl;								
				tMsg += "\n" + resBndl.getString( "msgAutoMsg" );	
				
				sender = resBndl.getString( "valSenderMail" );	
				senderClear = resBndl.getString( "valSenderClear" );
			
				mRes = mt.mailToUser( user, subj, tMsg, hMsg, sender, senderClear );
				
				if( res.checkRslt( mRes ) ) {
					
					msg1 += "<p>A notification note has been sent to the user.";
				}
			}
			
			if( res.notOK() ) {
				
				res.addRsltAddInfo( "'Add User': Sending out the mail failed." );
			}
			else {
				
				res.setString( msg1 );
			}
		}
		
		return res;		
	}
	
	// ---------------
	private String cleanStr( String p_Val ) {
		
		String val;
		
		val = p_Val.replaceAll( "'" , "_" );
		val = val.replace( "\"", "_" );
		
		return val;
	}
	
	// -----------------------------
	private RsltString DelBrnch( SrvltReqTools sTools, QNDBacc2 dBAcc, boolean isAdm ) {		

		RsltString res = new RsltString( true );
		
		String msg1;
		
		Rslt aRes;	

		if( !( isAdm ) ) {

			res.setInError( "You are not authorized to execute this task." );
		}

		RsltString rVal;
		String val;
		String whereStat; 

		rVal = sTools.getVal( "Val" );

		if( !res.checkRslt( rVal ) ) {
			
			res.addRsltAddInfo( "Retrieving the param failed." );
		}
		else {

			dBAcc.m_DB.startTrans();
			
			val = rVal.getString();
			val = dBAcc.m_DB.escapeStr2( val );

			whereStat = "Name = 'DevBranch' AND Val = '" + val + "'";

			aRes = dBAcc.m_DB.delete( "DataLst", whereStat );

			if( !res.checkRslt( aRes ) ) {
				
				res.addRsltAddInfo( "Delete of Branch failed." );
			}
		}

		dBAcc.m_DB.doCommit( res.isOK() );

		msg1 = "Branch '" + rVal.getString() + "' was deleted.";
		
		if( res.notOK() ) {
			
			res.addRsltAddInfo( "'Del Branch' failed." );
		}
		else {
			
			res.setString( msg1 );
		}

		return res;			
	}	
	
	// -----------------------------
	private RsltString DelGrp( SrvltReqTools sTools, QNDBacc2 dBAcc, boolean isAdm ) {		

		RsltString res = new RsltString( true );

		String group;
		String msg1;
		
		Rslt aRes;

		if( !( isAdm ) ) {

			res.setInError( "You are not authorized to execute this task." );
		}

		RsltString grp;
		String whereStat; 

		grp = sTools.getVal( "Grp" );

		if( !res.checkRslt( grp ) ) {
			
			res.addRsltAddInfo( "Retrieving the param failed." );
		}
		else {

			dBAcc.m_DB.startTrans();
			
			group = grp.getString();
			group = dBAcc.m_DB.escapeStr2( group );

			whereStat = "Name = '" + group + "'";

			aRes = dBAcc.m_DB.delete( "UGroups", whereStat );

			if( !res.checkRslt( aRes ) ) {
				
				res.addRsltAddInfo( "Delete from 'UGroups' failed." );
			}
		}

		dBAcc.m_DB.doCommit( res.isOK() );

		msg1 = "Group '" + grp.getString() + "' was deleted.";
		
		if( res.notOK() ) {
			
			res.addRsltAddInfo( "'Del Grp' failed." );
		}
		else {
			
			res.setString( msg1 );
		}

		return res;			
	}		
	
	// -----------------------------
	private RsltString DelP( SrvltReqTools sTools, QNDBacc2 dBAcc, boolean isAdm ) {		

		RsltString res = new RsltString( true );

		RsltString rUser;
		RsltString rProd;
		RsltString rRel;

		String whereStat; 

		String user;
		
		Rslt aRes;

		if( !( isAdm ) ) {

			res.setInError( "You are not authorized to execute this task." );
		}

		rUser = sTools.getVal( "User" );
		rProd = sTools.getVal( "Prod" );
		rRel = sTools.getVal( "Rel" );

		if( !res.checkRslt( rProd ) ) {
			
			res.addRsltAddInfo( "Retrieving the param failed." );
		}
		else {

			dBAcc.m_DB.startTrans();
			
			user = rUser.getString();
			user = dBAcc.m_DB.escapeStr2( user );
			
			String prod = rProd.getString();
			prod = dBAcc.m_DB.escapeStr2( prod );		
			
			String rel = rRel.getString();
			rel = dBAcc.m_DB.escapeStr2( rel );			
			
			whereStat = "Name = '" + user + "' AND Prod = '" + prod + "' AND Rel = '" + rel + "'";

			aRes = dBAcc.m_DB.delete( "UserProds", whereStat );

			if( !res.checkRslt( aRes ) ) {
				
				res.addRsltAddInfo( "Delete from 'UserProds' failed." );
			}
		}

		dBAcc.m_DB.doCommit( res.isOK() );
		
		if( res.notOK() ) {
			
			res.addRsltAddInfo( "'Del Product' failed." );
		}
		else {
			
			res.setString( "Product '" + rProd.getString() + "' was deleted for user '" + rUser.getString() + "'." );
		}
		
//res.appString( "<br>" + dBAcc.m_DB.m_LastQCmnd );

		return res;				
	}
	
	// -----------------------------
	private RsltString DelProd( SrvltReqTools sTools, QNDBacc2 dBAcc, boolean isAdm ) {		

		RsltString res = new RsltString( true );
		
		String msg1;
		
		Rslt aRes;	

		if( !( isAdm ) ) {

			res.setInError( "You are not authorized to execute this task." );
		}

		RsltString rPrd;
		String prod;
		String whereStat; 

		rPrd = sTools.getVal( "Prod" );

		if( !res.checkRslt( rPrd ) ) {
			
			res.addRsltAddInfo( "Retrieving the param failed." );
		}
		else {

			dBAcc.m_DB.startTrans();
			
			prod = rPrd.getString();
			prod = dBAcc.m_DB.escapeStr2( prod );

			whereStat = "Name = '" + prod + "'";

			aRes = dBAcc.m_DB.delete( "Prods", whereStat );

			if( !res.checkRslt( aRes ) ) {
				
				res.addRsltAddInfo( "Delete from 'Prods' failed." );
			}
		}

		dBAcc.m_DB.doCommit( res.isOK() );

		msg1 = "Product '" + rPrd.getString() + "' was deleted.";
		
		if( res.notOK() ) {
			
			res.addRsltAddInfo( "'Del Prod' failed." );
		}
		else {
			
			res.setString( msg1 );
		}

		return res;			
	}	

	// -----------------------------
	private RsltString DelR( SrvltReqTools sTools, QNDBacc2 dBAcc, boolean isAdm ) {		

		RsltString res = new RsltString( true );

		RsltString User;

		String msg1;
		String user;
		
		Rslt aRes;

		if( !( isAdm ) ) {

			res.setInError( "You are not authorized to execute this task." );
		}

		String whereStat; 
		RsltString Role = new RsltString();

		User = sTools.getVal( "User" );
		
		if( res.checkRslt( User ) ) {
			
			Role = sTools.getVal( "Role" );
		}

		if( !res.checkRslt( Role ) ) {
			
			res.addRsltAddInfo( "Retrieving the param failed." );
		}
		else {

			dBAcc.m_DB.startTrans();
			
			user = User.getString();
			user = dBAcc.m_DB.escapeStr2( user );

			whereStat = "Name = '" + user + "' AND Role = '" + Role.getString() + "'";

			aRes = dBAcc.m_DB.delete( "UserRoles", whereStat );

			if( !res.checkRslt( aRes ) ) {
				
				res.addRsltAddInfo( "Delete from 'UserRoles' failed." );
			}
		}

		dBAcc.m_DB.doCommit( res.isOK() );

		msg1 = "Role '" + Role.getString() + "' was deleted for user '" + User.getString() + "'.";
		
		if( res.notOK() ) {
			
			res.addRsltAddInfo( "'Del Role' failed." );
		}
		else {
			
			res.setString( msg1 );
		}
	
		return res;		
	}

	// -----------------------------
	private RsltString DelRel( SrvltReqTools sTools, QNDBacc2 dBAcc, boolean isAdm ) {		

		RsltString res = new RsltString( true );
		
		String msg1;
		
		Rslt aRes;		

		if( !( isAdm ) ) {

			res.setInError( "You are not authorized to execute this task." );
		}

		RsltString rPrd;
		String prod;
		RsltString rRel;
		String rel;				
		String whereStat; 

		rPrd = sTools.getVal( "Prod" );
		rRel = sTools.getVal( "Rel" );				

		if( !res.checkRslt( rRel ) ) {
			
			res.addRsltAddInfo( "Retrieving the param failed." );
		}
		else {

			dBAcc.m_DB.startTrans();
			
			prod = rPrd.getString();
			prod = dBAcc.m_DB.escapeStr2( prod );
			
			rel = rRel.getString();
			rel = dBAcc.m_DB.escapeStr2( rel );					

			whereStat = "Prod = '" + prod + "' AND Rel = '" + rel + "'";

			aRes = dBAcc.m_DB.delete( "ProdRels", whereStat );

			if( !res.checkRslt( aRes ) ) {
				
				res.addRsltAddInfo( "Delete from 'ProdRels' failed." );
			}
		}

		dBAcc.m_DB.doCommit( res.isOK() );

		msg1 = "Release '" + rRel.getString() + "' was deleted.";
		
		if( res.notOK() ) {
			
			res.addRsltAddInfo( "'Del Rel' failed." );
		}
		else {
			
			res.setString( msg1 );
		}
	
		return res;		
	}
	
	// -----------------------------
	private RsltString DelSys( SrvltReqTools sTools, QNDBacc2 dBAcc, boolean isAdm ) {		

		RsltString res = new RsltString( true );
		
		String msg1;
		
		Rslt aRes;	

		if( !( isAdm ) ) {

			res.setInError( "You are not authorized to execute this task." );
		}

		RsltString rSys;
		String sys;
		String whereStat; 

		rSys = sTools.getVal( "Sys" );

		if( !res.checkRslt( rSys ) ) {
			
			res.addRsltAddInfo( "Retrieving the param failed." );
		}
		else {

			dBAcc.m_DB.startTrans();
			
			sys = rSys.getString();
			sys = dBAcc.m_DB.escapeStr2( sys );

			whereStat = "Name = '" + sys + "'";

			aRes = dBAcc.m_DB.delete( "Systems", whereStat );

			if( !res.checkRslt( aRes ) ) {
				
				res.addRsltAddInfo( "Delete from 'Systems' failed." );
			}
		}

		dBAcc.m_DB.doCommit( res.isOK() );

		msg1 = "System '" + rSys.getString() + "' was deleted.";
		
		if( res.notOK() ) {
			
			res.addRsltAddInfo( "'Del Sys' failed." );
		}
		else {
			
			res.setString( msg1 );
		}
	
		return res;	
	}		
	
	// -----------------------------
	private RsltString DelU( SrvltReqTools sTools, QNDBacc2 dBAcc, boolean isAdm ) {		

		RsltString res = new RsltString( true );

		RsltString User;

		String msg1;
		String user;
		
		Rslt aRes;	

		if( !( isAdm ) ) {

			res.setInError( "You are not authorized to execute this task." );
		}

		String whereStat; 

		User = sTools.getVal( "User" );

		if( !res.checkRslt( User ) ) {
			
			res.addRsltAddInfo( "Retrieving the param failed." );
		}
		else {

			dBAcc.m_DB.startTrans();

			user = User.getString();
			user = dBAcc.m_DB.escapeStr2( user );
			whereStat = "Name = '" + user + "'";

			aRes = dBAcc.m_DB.delete( "UserProds", whereStat );
			
			if( !res.checkRslt( aRes ) ) {
				
				res.addRsltAddInfo( "Delete from 'UserProds' failed." );
			}
			else {
				
				aRes = dBAcc.m_DB.delete( "UserRoles", whereStat );
			}

			if( !res.checkRslt( aRes ) ) {
				
				res.addRsltAddInfo( "Delete from 'UserRoles' failed." );
			}
			else {
			
				aRes = dBAcc.m_DB.delete( "Users", whereStat );
				
				if( !res.checkRslt( aRes ) ) {
					
					res.addRsltAddInfo( "Delete from 'Users' failed." );
				}
			}
		}

		dBAcc.m_DB.doCommit( res.isOK() );

		msg1 = "User '" + User.getString() + "' was deleted.";
		
		if( res.notOK() ) {
			
			res.addRsltAddInfo( "'Del User' failed." );
		}
		else {
			
			res.setString( msg1 );
		}

		return res;			
	}
	

	// -----------------------------
	private RsltString SetGrp( SrvltReqTools sTools, QNDBacc2 dBAcc, boolean isAdm ) {		

		RsltString res = new RsltString( true );
		
		RsltString User;
		RsltString Grp;
		
		String LogUser;
		String msg1;
		
		SQLRslt aRes;

		LogUser = sTools.m_Req.getRemoteUser();

		User = sTools.getVal( "User" );

		if( User.getString().compareTo( LogUser ) != 0 ) {
		
			if( !( isAdm ) ) {

				res.setInError( "You are not authorized to execute this task." );
			}
		}

		Grp = sTools.getVal( "UGroup" );

		if( !res.checkRslt( Grp ) ) {
			
			res.addRsltAddInfo( "Retrieving the param failed." );
		}
		else {

			dBAcc.m_DB.startTrans();

			QuerySet qSet = new QuerySet( 2, "Users" );

			qSet.addKeyCol( "Name", User.getString(), true );
			qSet.addQCol( "UGroup", Grp.getString(), false );

			aRes = dBAcc.m_DB.update( qSet );

			if( !res.checkRslt( aRes ) ) {
				
				res.addRsltAddInfo( "Update of 'Users' failed." );
			}
		}

		dBAcc.m_DB.doCommit( res.isOK() );

		msg1 = "The group for user '" + User.getString() + "' was updated.";
		
		if( res.notOK() ) {
			
			res.addRsltAddInfo( "'Set Group' failed." );
		}
		else {
			
			res.setString( msg1 );
		}
		
		return res;		
	}
	
	
	// -----------------
	private RsltString SetMail( SrvltReqTools sTools, QNDBacc2 dBAcc, boolean isAdm ) {
		
		RsltString res = new RsltString( true );
		
		RsltString User;
		String LogUser;
		String mail;
		String msg1;
		RsltString Mail;
		
		SQLRslt aRes;
	
		LogUser = sTools.m_Req.getRemoteUser();
	
		User = sTools.getVal( "User" );
	
		if( User.getString().compareTo( LogUser ) != 0 ) {
		
			if( !( isAdm ) ) {
	
				res.setInError( "You are not authorized to execute this task." );
			}
		}
	
		Mail = sTools.getVal( "Mail" );
	
		if( !res.checkRslt( Mail ) ) {
			
			res.addRsltAddInfo( "Retrieving the param failed." );
		}
		else {
	
			mail = cleanStr( Mail.getString() );					
			
			dBAcc.m_DB.startTrans();
	
			QuerySet qSet = new QuerySet( 2, "Users" );
	
			qSet.addKeyCol( "Name", User.getString(), true );
			qSet.addQCol( "Mail", mail, false );
	
			aRes = dBAcc.m_DB.update( qSet );
	
			if( !res.checkRslt( aRes ) ) {
				
				res.addRsltAddInfo( "Update of 'Users' failed." );
			}
		}
	
		dBAcc.m_DB.doCommit( res.isOK() );
	
		msg1 = "The mail ID for user '" + User.getString() + "' was updated.";
		
		if( res.notOK() ) {
			
			res.addRsltAddInfo( "'Set Mail' failed." );
		}
		else {
			
			res.setString( msg1 );
		}
		
		return res;
	}
	
	// -----------------
	private RsltString SetPW( SrvltReqTools sTools, QNDBacc2 dBAcc, boolean isAdm ) {
		
		RsltString res = new RsltString( true );
		
		RsltString User;
		String LogUser;
		String msg1;
		
		SQLRslt aRes;

		RsltString PW;
		String dig;

		User = sTools.getVal( "User" );

		LogUser = sTools.m_Req.getRemoteUser();

		if( User.getString().compareTo( LogUser ) != 0 ) {
		
			if( !( isAdm ) ) {

				res.setInError( "You are not authorized to execute this task." );
			}
		}

		PW = sTools.getVal( "PW" );

		if( !res.checkRslt( PW ) ) {
			
			res.addRsltAddInfo( "Retrieving the param failed." );
		}
		else {
			
			dBAcc.m_DB.startTrans();

			QuerySet qSet = new QuerySet( 2, "Users" );

			dig = SFormatter.digestSHA( PW.getString() );

			qSet.addKeyCol( "Name", User.getString(), true );
			qSet.addQCol( "PW", dig, false );

			aRes = dBAcc.m_DB.update( qSet );

			if( !res.checkRslt( aRes ) ) {
				
				res.addRsltAddInfo( "Update of 'Users' failed." );
			}
		}

		dBAcc.m_DB.doCommit( res.isOK() );

		msg1 = "The password for user '" + User.getString() + "' was updated.";
		
		if( res.notOK() ) {
			
			res.addRsltAddInfo( "'Set PW' failed." );
		}
		else {
			
			res.setString( msg1 );
		}
		
		return res;		
	}
}
