package RTObj;

import com.qanavigation.Basics.BTools;
import com.qanavigation.Basics.Rslt;
import com.qanavigation.Basics.RsltString;
import com.qanavigation.Basics.RsltTable;
import com.qanavigation.DBacc.DBacc2;
import com.qanavigation.QNservices.QNDefs;
import com.qanavigation.QNservices.QNRepBld;
import com.qanavigation.QNservices.SrvltReqTools;
import com.qanavigation.QNservices.UserTool;
import com.qanavigation.XMLBasics.RsltXMLDoc;
import com.qanavigation.XMLBasics.RsltXMLNode;
import com.qanavigation.XMLDB.XMLDBNode;

public class IssRepBld extends QNRepBld {

	private String m_DocNum = "";
	
	/**
	 * 
	 * @param p_SRT
	 * @param p_FilePath
	 */
	public IssRepBld( DBacc2 p_DBacc, SrvltReqTools p_SRT, String p_FilePath ) {

		super( p_DBacc, p_SRT, p_FilePath, QNDefs.c_NodeIssReport);
				
		if( notOK() ) {
			
			addRsltAddInfo( "'IssRepBld.IssRepBld(..)' failed." );
		}
	}
	
	/**
	 * 
	 * @param p_IsDraft
	 */
	public void bldIssRep( boolean p_IsDraft ) {
		
		boolean bTolerant = false;
		
		Rslt aRes;
		RsltString rVal;
		
		//RsltXMLNode aNode;

		/*
		<!ELEMENT IssReport ( RefPR?, Text?, AddInfo*, AppFile*, LogEntry*, ProcLog* )>
			<!ATTLIST IssReport
				Assignd		CDATA #IMPLIED
				Author		CDATA #IMPLIED
				DateTime	NMTOKEN #REQUIRED
				IssStat		(as|at|bd|CfNR|rCfNR|cl|cr|ct|dr|du|es|ev|fx|nr|rj|rr|rt|re|rg|rs|rv|sb|sh|tf|ts|wf) "as"
				IssType		NMTOKEN #IMPLIED
				LastMod		NMTOKEN #IMPLIED
				LastModBy	CDATA #IMPLIED
				Lock			NMTOKEN #IMPLIED
				IssNum		NMTOKEN #IMPLIED
				Prio			NMTOKEN #IMPLIED
				Proj			CDATA #IMPLIED
				Title			CDATA #REQUIRED
				UID				NMTOKEN #IMPLIED
			>
		
			<!ELEMENT Text (#PCDATA)>
				<!ATTLIST Text
					UID			NMTOKEN #IMPLIED
				>
					
		*/
		
		try {
			
			if( p_IsDraft ) {
				
				bTolerant = true;		
			}
			
			m_xDoc = new RsltXMLDoc( "", QNDefs.c_NodeIssReport, QNDefs.c_IssRepDTD, null );
			
			if(	checkRslt( m_xDoc ) ) {
				
				RsltXMLNode tNode = m_xDoc.getTopNode();
				
				if( p_IsDraft ) {
					
					//tNode.addAttribute( "Assignd", "" );
					appAttr( tNode,  "Author", "Assignd", false );
				}
				else {
					
					UserTool ut = new UserTool( m_xDB.m_DB );
					
					rVal = ut.getIssSuper();
					
					if( checkRslt( rVal ) ) {
						
						tNode.addAttribute( "Assignd", rVal.getString() );	
					}
				}
				
				checkRslt( tNode );
				
				checkRslt( m_SRT );
				
				appAttr( tNode, "Author", false );
								
				appDateTime( tNode, "Date", "Time", "DateTime", bTolerant );
				
				appAttr( tNode, "IssStat", bTolerant );	
				
				appAttr( tNode, "IssType", bTolerant );	
				
				appAttr( tNode, "IssNum", bTolerant );					
				
				appAttr( tNode, "Prio", true );
				
				appAttr( tNode, "Proj", true );	
				
				appAttr( tNode, "Title", bTolerant );
				
				rVal = m_SRT.getVal( "UID" );
				
				if( rVal.getString().length() > 0 ) {
					
					tNode.addAttribute( "UID", rVal.getString() );
				}
				
				appTxtNode( tNode, "Text", true );
				
				aRes = appExistFiles( tNode );
				
				if( aRes.isOK( true ) ) {
				
					aRes = appExistLogs( tNode );					
				}
				
				if( aRes.isOK( true ) ) {
					
//					m_IsLoaded = true;
				}
				else {
					
					setRsltStat( aRes );
				}
			}
		}
		catch( Exception excp ) {
			
			setRsltByExcp( excp );
		}
		
		if( notOK() ) {

			addRsltAddInfo( "'IssRepBld.bldProbRep(..)' failed." );
		}
		else {
			
			m_XDocIsInit = true;
		}
	}	
	
	/**
	 * 
	 * @return
	 */
	public String getDocNum() {
		
		return m_DocNum;
	}	
	
	/**
	 * 
	 * @param p_UID
	 * @return
	 */
	public Rslt loadIssData( String p_UID ) {
		
		Rslt res = new Rslt( true );

		RsltString val;
		RsltTable attrs;
		
		XMLDBNode xNode;
		
		xNode = m_xDB.getXMLsubTree( p_UID );
		
		if( res.checkRslt( xNode ) ) {
			
			m_xDoc = xNode.m_RxDoc;
			
			attrs = m_xDB.getNodeAttrs( p_UID );
			
			if( res.checkRslt( attrs ) ) {
				
				m_SRT.add2ParamLst( attrs );
			}
	
			val = xNode.getSubNodeVal( QNDefs.c_NodeTxt );
			
			if( res.checkRslt( val, true ) ) {
				
				m_SRT.add2ParamLst( QNDefs.c_NodeTxt, val.getString() );
			}
			
			if( res.isOK( true ) ) {
				
//				m_IsLoaded = true;
				m_XDocIsInit = true;
			}
		}
		
		if( !checkRslt( res ) ) {

			addRsltAddInfo( "'IssRepBld.loadIssData(..)' failed." );
		}
		
		return res;	
	}
	
	/**
	 * 
	 * @param p_IsDraft
	 * @return
	 */
	public RsltString save2DB( String p_Author, boolean p_IsDraft ) {
		
		Rslt res;
		RsltString UID = new RsltString( true );
		RsltString rVal;
		RsltXMLNode node;
		
		String dateTime;

		try {
			
			if( !( m_XDocIsInit ) ) {

				UID.setInError( "m_xDoc not init." );
			}
			else {
				
				node = m_xDoc.getTopNode();
				
				if( !( p_IsDraft ) ) {
					
					rVal = node.getAttrVal( QNDefs.c_AttrIssNum );
					
					if( rVal.getString().length() > 0 ) {
						
						m_DocNum = rVal.getString();
						
//UID.setInError( "Has attr val '" + m_DocNum + "'" );
					}
					else {
					
						/* Appending doc number at save */
						rVal = m_xDB.m_DB.getIncrCounter( "Counters", "PRCount" );
						
						if( UID.checkRslt( rVal ) ) {
							
							m_DocNum = rVal.getString();
	
							node.addAttribute( QNDefs.c_AttrIssNum, m_DocNum );
//UID.setInError( "New attr val '" + m_DocNum + "'" );							
						}
					}
				}
				else {
					
//UID.setInError( "Is draft." );					
				}
				
				dateTime = BTools.getNowISODateTimeSec();
				
				res = storeFile( node, p_Author, "FileDesc", dateTime );
				
				if( UID.checkRslt( res, true ) ) {
					
					UID = super.save2DB( m_xDoc );
				}
			}
		}
		catch( Exception excp ) {
			
			UID.setRsltByExcp( excp );
		}
		
		if( !checkRslt( UID ) ) {

			addRsltAddInfo( "'IssRepBld.save2DB(..)' failed." );
		}
				
		return UID;
	}
}
