// QANav Report Tracker Copyright 2008 -2009 Ronald D. Grindle

package RTObj;

import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;

import RTtools.TRStat;

import com.qanavigation.Basics.Rslt;
import com.qanavigation.Basics.RsltString;
import com.qanavigation.Basics.SFormatter;
import com.qanavigation.QNservices.QNDBacc2;
import com.qanavigation.QNservices.QNDefs;

/**
 * Technical Report Edit Object
 * @author RGDM2
 *
 */
public class TRObj extends TRRepObj {
	
	public boolean m_isNewTstProb; // problem from executing a TC
	
	public String m_tcExTitle = "";
	public String m_tcExUid = "";
	public String m_tcUid = "";

	/**
	 * 
	 * @param p_Request
	 * @param p_dBAcc
	 */
	public TRObj( HttpServlet p_Srvl, HttpServletRequest p_Request, QNDBacc2 p_dBAcc ) {

		super( p_Srvl, p_Request, p_dBAcc );
		
		m_isNewTstProb = false;

		if( notOK() ) {
			
			addRsltAddFailInfo( "TRObj", "TRObj", "", "" );
		}	
	}
	
	/**
	 * 
	 * @return
	 */
	public String getFunc() {
		
		RsltString rVal;
		
		String str;
		
		if( m_isNewTstProb ) {
			
			str = "";
	
			if( m_tcUid.length() > 0 ) {
	
				rVal = m_xDB.getAttrVal( m_tcUid, "Fctn" );
		
				str += rVal.getString();
			}
		}
		else {
	
			//old version: locked, lost by file upload. How continue? oStr += sTools.getInTail( "Fctn" );
			
			str = m_trb.getVal( "Fctn" );
		}
		
		return str;
	}
	
	// ------------------
	private Rslt handleEdit( boolean isEdit  ) {

		Rslt res = new Rslt( true );
		
		RsltString rVal;
		
		String author;
		String msg;
		
		if( isEdit ) {

			if( res.checkRslt( m_UID ) ) {
	
				res = m_trb.loadPRData( m_UID.getString() ); 
	
				rVal = m_sTools.getVal( "Author" );
	
				author = rVal.getString();
	
				if( m_User.compareTo( author ) != 0 ) {
	
					msg = SFormatter.format( m_resBndl.getString( "msgLastAuthorWas" ), author );  
	
					m_trb.appProcLogX( m_UID.getString(), msg );
				}
			}
			
			if( res.notOK() ) {
				
				res.addRsltAddInfo( "TRObj.handleEdit() failed." );
			}
		}
		
		return res;
	}
	
	/**
	 * 
	 * @return
	 */
	public Rslt initObj() {
		
		boolean isSub;
		
		String QNA;
		
		Rslt res = new Rslt( true );
		
		RsltString rVal;
		
		isSub = false;
		
		m_modeIsUpl = false;
		m_modeIsDel = false;
		m_modeIsEdit = false;
		m_isHandled = false;

		if( isOK() ) {

			m_isNewTstProb = m_sTools.checkVal( "ProbType", "Test" );
			
			// Checking the request
			QNA = m_sTools.getStrVal( "QNA" );
			
			m_UID = m_sTools.getVal( "UID" );

			if( 0 == QNA.compareTo( "RepProb" ) ) {
				
				m_isHandled = true;
			}
		
			if( !( m_isHandled ) ) {

				if( 0 == QNA.compareTo( "UplProb" ) ) {
	
					m_isHandled = true;
					m_modeIsUpl = true;
					m_statIsDraft = true;
				}
			}
			
			if( !( m_isHandled ) ) {

				if( 0 == QNA.compareTo( "DelFile" ) ) {

					m_isHandled = true;
					m_modeIsDel = true;
					m_statIsDraft = true;
				}
			}
			
			if( !( m_isHandled ) ) {

				if( 0 == QNA.compareTo( "EditProb" ) ) {

					m_isHandled = true;
					m_modeIsEdit = true;						
				}
			}
			
			if( !( m_isHandled ) ) {
				
				res.setInError( "Unknown request '" + QNA + "'." );
			}
		}
		
		if( res.isOK() && ( m_modeIsUpl || m_modeIsDel || m_modeIsEdit ) ) {

			m_RepStat = m_trb.getVal( QNDefs.c_AttrProbStat );
			
			if( m_RepStat.length() < 1 ) {
				
				m_RepStat = getRepStat( QNDefs.c_AttrProbStat );
			}			
		
			TRStat prStatObj = new TRStat( m_RepStat );
				
			isSub = prStatObj.isSub();
			m_modeIsEdit2 = prStatObj.nextEdit2( true );
			
			if( m_modeIsEdit2 ) {
				
				m_ro = " readonly=\"true\"";
				m_cRo = "class=\"ro\" ";
			}
		}
		
		// Building the Report ------
		if( res.isOK() && m_modeIsDel ) {

			res = handleDelFile();
		}

		if( res.isOK() && ( m_modeIsDel || m_modeIsUpl ) ) {
			
			rVal = handleSave( m_statIsDraft, isSub );
			
			m_UID = rVal;
		}
			
		if( res.isOK() ) {
			
			res = handleEdit( m_modeIsEdit );
		}
		
		if( res.isOK() ) {
			
			res = prepTCex();
		}		
		
		if( res.notOK() ) {
			
			res.addRsltAddInfo( "TRObj.initObj() failed." );
		}
		
		return res;
	}
	
	// -------------------------
	private Rslt prepTCex( ) {
		
		Rslt res = new Rslt( true );
		
		RsltString rVal;
		
		m_tcExUid = m_trb.getVal( "TCExUID" );

		if( m_isNewTstProb ) {

			rVal = m_xDB.getAttrVal( m_tcExUid, "Cmpgn" );

			if( res.checkRslt( rVal ) ) {

				m_tcExTitle += rVal.getString() + ": ";
			}

			rVal = m_xDB.getAttrVal( m_tcExUid, "Title" );

			if( res.checkRslt( rVal ) ) {

				m_tcExTitle += rVal.getString();
			}
		}
		else {

			m_tcExTitle = m_trb.getVal( "TCExTitle" );
		}
		
		if( res.notOK() ) {
			
			res.addRsltAddInfo( "TRObj.prepTCex() failed." );
		}	
		
		return res;
	}	
}
