//---------------------------------------------------------
//QA Navigator SLMT Services Collection
//Copyright � 2009 Ronald D. Grindle
//---------------------------------------------------------

package RTtools;

import javax.servlet.http.HttpServletRequest;

import com.qanavigation.Basics.RsltString;
import com.qanavigation.Basics.RsltTable;
import com.qanavigation.QNservices.QNDefs;
import com.qanavigation.QNservices.UserTool;
import com.qanavigation.XMLDB.XMLDB;

/**
 * 
 * 
 *
 */
public class UserRoleTool extends UserTool {
	
	public XMLDB m_xDB;
	
	public HttpServletRequest m_Request;
	
	public boolean m_roleIsAdm = false;
	public boolean m_roleIsBA = false;
	public boolean m_roleIsClient = false;
	public boolean m_roleIsCoo = false;
	public boolean m_roleIsDflt = false;
	public boolean m_roleIsDev = false;
	public boolean m_roleIsDpl = false;
	public boolean m_roleIsProd = false;
	public boolean m_roleIsSrvc = false;
	public boolean m_roleIsSup = false;
	public boolean m_roleIsSysTst = false;
	public boolean m_roleIsTst = false;
	
	public String m_user; 

	/**
	 * 
	 * @param p_xDB
	 *
	*
	public UserRoleTool( XMLDB p_xDB, String p_user ) {
		
		m_xDB = p_xDB;
		
		setRsltStat( p_xDB );
	}*/
	
	/**
	 * @param p_Request
	 */
	public UserRoleTool( HttpServletRequest p_Request, XMLDB p_xDB ) {
		
		super( p_xDB.m_DB );
		
		m_xDB = p_xDB;
		
		m_Request = p_Request;
	
		init();
		
		setRsltStat( p_xDB );
	}
	
	/*
roleLbl += " " + m_resBndl.getString( "valRole_co" );
roleLbl = m_resBndl.getString( "valRole_adm" );
roleLbl = m_resBndl.getString( "valRole_dev" );	
roleLbl = m_resBndl.getString( "valRole_lvl1" );
roleLbl = m_resBndl.getString( "valRole_cl" );
roleLbl = m_resBndl.getString( "valRole_ba" );
roleLbl = m_resBndl.getString( "valRole_dpl" );
roleLbl = m_resBndl.getString( "valRole_sp" );
roleLbl = m_resBndl.getString( "valRole_lvl2" );
roleLbl = m_resBndl.getString( "valRole_lvl3" );
roleLbl = m_resBndl.getString( "valRole_tst" );
	 */
	
	/**
	 *
	 * @return
	 */
	public boolean canAssgnCR( /*boolean p_IsInYGrp*/ ) {
		
		boolean isTrue = false;
		
		isTrue = m_roleIsBA;
		isTrue |= m_roleIsDev;
		isTrue |= m_roleIsDpl;
		isTrue |= m_roleIsTst;
		//isTrue &= ( m_roleIsSup || m_roleIsCoo || m_roleIsAdm ); 		
		
		return isTrue;
	}
	
	/**
	 *
	 * @return
	 */
	public boolean canAssgnIss( /*boolean p_IsInYGrp*/ ) {
		
		boolean isTrue = false;
		
		isTrue = m_roleIsBA;
		isTrue |= m_roleIsDev;
		isTrue |= m_roleIsDpl;
		isTrue |= m_roleIsTst;
		//isTrue &= ( m_roleIsSup || m_roleIsCoo || m_roleIsAdm ); 
		
		return isTrue;
	}	
	
	/**
	 *
	 * @return
	 */
	public boolean canAssgnTR( /*boolean p_IsInYGrp*/ ) {
		
		boolean isTrue = false;
		
		isTrue = m_roleIsDev;
		isTrue |= m_roleIsDpl;
		isTrue |= m_roleIsTst;
		//isTrue &= ( m_roleIsSup || m_roleIsCoo || m_roleIsAdm ); 
		
		return isTrue;
	}
	
	/**
	 *
	 * @return
	 */
	public boolean canAssTstTR( ) {
		
		boolean isTrue = false;
		
		isTrue = isTstCoo();
		//isTrue |= isTRCoo();
		
		return isTrue;
	}
	
	/**
	 * 
	 * @param p_isYours
	 * @return
	 */
	public boolean canDelNewCR( boolean p_isYours ) {
		
		boolean isTrue = false;
		
		isTrue = p_isYours;
		isTrue |= isCRSuper();
		
		return isTrue;
	}

	/**
	 * 
	 * @param p_isYours
	 * @return
	 */
	public boolean canDelNewTR( boolean p_isYours ) {
		
		boolean isTrue = false;
		
		isTrue = p_isYours;
		isTrue |= isTRSuper();
		
		return isTrue;
	}

	/**
	 * 
	 * @param p_isYours
	 * @return
	 */
	public boolean canDelShp( boolean p_isYours ) {
		
		boolean isTrue = false;
		
		isTrue = p_isYours;
		isTrue &= isDplSuper();
		
		return isTrue;
	}	
	
	/**
	 * 
	 * @param p_isYours
	 * @return
	 */
	public boolean canEditFix( boolean p_isYours ) {
		
		boolean isTrue = false;
		
		isTrue = p_isYours;
		isTrue |= isTRCoo();
		
		return isTrue;
	}

	/**
	 * 
	 * @return
	 */
	public boolean canExTstTR( boolean p_isYours ) {
		
		boolean isTrue = false;
		
		isTrue = p_isYours;
		isTrue &= isTstSrvc();
		
		return isTrue;
	}

	/**
	 * 
	 * @return
	 */
	public boolean canManCR( ) {
		
		boolean isTrue = false;
		
		isTrue = isCRSuper();
		
		return isTrue;
	}

	/**
	 * 
	 * @return
	 */
	public boolean canManFix( ) {
		
		boolean isTrue = false;
		
		isTrue = isFixSuper();
		
		return isTrue;
	}

	/**
	 * 
	 * @return
	 */
	public boolean canManIss( ) {
		
		boolean isTrue = false;
		
		isTrue = isIssSuper();
		
		return isTrue;
	}	
	
	/**
	 * 
	 * @return
	 */
	public boolean canManShpDoc( ) {
		
		boolean isTrue = false;
		
		isTrue = isShpSuper();
		
		return isTrue;
	}
	
	/**
	 * 
	 * @return
	 */
	public boolean canManTR( ) {
		
		boolean isTrue = false;
		
		isTrue = isTRSuper();
		
		return isTrue;
	}
	
	/**
	 * 
	 * @return
	 */
	public boolean canMngCR( boolean p_isYours ) {
		
		boolean isTrue = false;
		
		isTrue = p_isYours;
		isTrue |= isCRCoo();
		
		return isTrue;
	}
	
	/**
	 * 
	 * @return
	 */
	public boolean canMngShpDoc( boolean p_isInYourGroup ) {
		
		boolean isTrue = false;
		
		isTrue = p_isInYourGroup;
		isTrue |= isShpCoo();
		
		return isTrue;
	}	
	
	/**
	 * 
	 * @return
	 */
	public boolean canMngTR( boolean p_isYours ) {
		
		boolean isTrue = false;
		
		isTrue = p_isYours;
		isTrue |= isTRCoo();
		
		return isTrue;
	}
	
	/**
	 * 
	 * @return
	 */
	public boolean canProcCR( boolean p_isYours ) {
		
		boolean isTrue = false;
		
		isTrue = p_isYours;
		isTrue |= isCRCoo();
		
		return isTrue;
	}

	/**
	 * 
	 * @return
	 */
	public boolean canProcShp( boolean p_isYours ) {
		
		boolean isTrue = false;
		
		isTrue = p_isYours;
		isTrue &= m_roleIsDpl;
		
		return isTrue;
	}
	
	/**
	 * 
	 * @return
	 */
	public boolean canProcTR( boolean p_isYours ) {
		
		boolean isTrue = false;
		
		isTrue = p_isYours;
		
		return isTrue;
	}
	
	/**
	 * 
	 * @return
	 */
	public boolean canProdShp(  boolean p_isYours ) {
		
		boolean isTrue = false;

		isTrue = p_isYours;
		isTrue &= m_roleIsProd;
		
		return isTrue;
	}
	
	/**
	 * 
	 * @return
	 */
	public boolean canRejCR(  ) {
		
		boolean isTrue = false;

		isTrue = isCRCoo();
		
		return isTrue;
	}
	
	/**
	 * 
	 * @return
	 */
	public boolean canRejTR(  ) {
		
		boolean isTrue = false;

		isTrue = isTRCoo();
		
		return isTrue;
	}
	
	/**
	 * 
	 * @return
	 */
	public boolean canSetDraftCR( boolean p_isYours ) {
		
		boolean isTrue = false;
		
		//isTrue = p_isYours;
		isTrue |= isCRSuper();
		
		return isTrue;
	}
	
	/**
	 * 
	 * @return
	 */
	public boolean canSetDraftTR( boolean p_isYours ) {
		
		boolean isTrue = false;
		
		//isTrue = p_isYours;
		isTrue |= isTRSuper();
		
		return isTrue;
	}
	
	/**
	 * 
	 * @return
	 */
	public boolean canSetFixTst( ) {
		
		boolean isTrue = false;
		
		isTrue = m_roleIsDev;
		isTrue |= m_roleIsDpl;
		isTrue |= m_roleIsTst;
		
		return isTrue;
	}
	
	/**
	 * Can ship a tech report
	 * @return
	 */
	public boolean canShipTR( ) {
		
		boolean isTrue = false;
		
		isTrue = m_roleIsDpl;
		
		return isTrue;
	}
	
	/**
	 * Can sys test a shipment
	 * @return
	 */
	public boolean canTstShp( boolean p_isYours ) {
		
		boolean isTrue = false;
		
		isTrue = p_isYours;
		isTrue &= m_roleIsSysTst;
		
		return isTrue;
	}	
	
	/**
	 * Access to all CR
	 * @return
	 */
	public boolean canVAllCR( ) {
		
		boolean isTrue = false;
		
		isTrue = m_roleIsBA;
		isTrue |= m_roleIsDev;
		isTrue |= m_roleIsTst;
		isTrue |= m_roleIsDpl;
		
		return isTrue;
	}
	
	/**
	 * Access to all fix documents
	 * @return
	 */
	public boolean canVAllFix( ) {
		
		boolean isTrue = false;
		
		isTrue = m_roleIsTst;
		isTrue |= m_roleIsDev;
		isTrue |= m_roleIsDpl;
		
		return isTrue;
	}
	
	
	/**
	 * Access to all Iss
	 * @return
	 */
	public boolean canVAllIss( ) {
		
		boolean isTrue = false;
		
		isTrue = m_roleIsTst;
		isTrue |= m_roleIsDev;
		isTrue |= m_roleIsDpl;
		isTrue |= m_roleIsBA;
		
		return isTrue;
	}	
	
	/**
	 * Access to all TR
	 * @return
	 */
	public boolean canVAllTR( ) {
		
		boolean isTrue = false;
		
		isTrue = m_roleIsTst;
		isTrue |= m_roleIsDev;
		isTrue |= m_roleIsDpl;
		
		return isTrue;
	}
	
	/**
	 * 
	 * @param p_UID
	 * @param p_User
	 * @return
	 */
	public boolean docIsInYourGroup( String p_UID, String p_Group ) {
		
		boolean iiyg = false;
		
		RsltTable rTbl;
		
		String appx;
		String tableName;
		String aUser;
		
		String grp;
		
// ###################################		
		tableName = "Attrib";
		appx = " WHERE Name = 'Assignd' AND UIDpNode = '" + p_UID + "'";
								
		String colNames[] = { "Value" };
				
		rTbl = m_xDB.m_DB.select( tableName, colNames, appx );
		
		if( rTbl.isOK() ) {
			
			aUser = rTbl.getCell( 0, 0 );
			
			grp = getGroupForUser( aUser );
			
			if( grp.compareTo( p_Group ) == 0 ) {
				
				iiyg = true;
			}
		}

		return iiyg;
	}
	
	// -------------------
	protected void init() {
		
		m_user = m_Request.getRemoteUser();
		
		if( m_Request.isUserInRole( QNDefs.c_RoleClient ) ) {
			
			m_roleIsClient = true;
		}
		else {
		
			if( m_Request.isUserInRole( QNDefs.c_RoleAdmin ) ) {
				
				m_roleIsAdm = true;
			}
			
			if( m_Request.isUserInRole( QNDefs.c_RoleBA ) ) {
		
				m_roleIsBA = true;
			}
			
			if( m_Request.isUserInRole( QNDefs.c_RoleCo ) ) {
	
				m_roleIsCoo = true;
			}			
			
			if( m_Request.isUserInRole( QNDefs.c_RoleDev ) ) {
	
				m_roleIsDev = true;
			}
		
			if( m_Request.isUserInRole( QNDefs.c_RoleDpl ) ) {
		
				m_roleIsDpl = true;
			}
	
			if( m_Request.isUserInRole( QNDefs.c_RoleLvl1 ) ) {
				
				m_roleIsSrvc = true;
			}
	
			if( m_Request.isUserInRole( QNDefs.c_RoleLvl2 ) ) {
				
				m_roleIsSrvc = true;
			}
	
			if( m_Request.isUserInRole( QNDefs.c_RoleLvl3 ) ) {
				
				m_roleIsSrvc = true;
			}
			
			if( m_Request.isUserInRole( QNDefs.c_RoleProd ) ) {
				
				m_roleIsProd = true;
			}
			
			if( m_Request.isUserInRole( QNDefs.c_RoleSuper ) ) {
				
				m_roleIsSup = true;
			}
			
			if( m_Request.isUserInRole( QNDefs.c_RoleSysTst ) ) {
				
				m_roleIsSysTst = true;
			}			
	
			if( m_Request.isUserInRole( QNDefs.c_RoleTest ) ) {
	
				m_roleIsTst = true;
			}
		}
	}
	
	/**
	 * 
	 * @return
	 */
	public boolean isCRCoo( ) {
		
		boolean isTrue = false;
		
		isTrue = m_roleIsAdm;
		isTrue |= m_roleIsSup;
		isTrue |= m_roleIsCoo;
		isTrue &= m_roleIsBA;
		
		return isTrue;
	}
	
	/**
	 * 
	 * @return
	 */
	public boolean isCRInYGrp( String p_DocUID ) {
		
		boolean isTrue = false;
	
		if( isCRSuper() ) {
	
			isTrue = true;
		}
		else {
	
			isTrue = isInYGrp( p_DocUID );
		}
		
		return isTrue;		
	}
	
	/**
	 * 
	 * @return
	 */
	public boolean isCRSrvc( ) {
		
		boolean isTrue = false;
		
		isTrue = m_roleIsTst;
		isTrue |= m_roleIsDev;
		isTrue |= m_roleIsDpl;
		isTrue |= m_roleIsBA;
		
		return isTrue;
	}
	
	/**
	 * 
	 * @return
	 */
	public boolean isCRSuper( ) {
		
		boolean isTrue = false;
		
		isTrue = m_roleIsAdm;
		isTrue |= m_roleIsSup;
		isTrue &= m_roleIsBA;
		
		return isTrue;
	}
	
	/**
	 * AcDeployment Service
	 * @return
	 */
	public boolean isDplSrvc( ) {
		
		boolean isTrue = false;
		
		isTrue = m_roleIsAdm;
		isTrue |= m_roleIsDpl;
		
		return isTrue;
	}
	
	/**
	 * Deployment Supervisor
	 * @return
	 */
	public boolean isDplSuper( ) {
		
		boolean isTrue = false;
		
		isTrue = m_roleIsAdm;
		isTrue |= m_roleIsSup;
		isTrue &= m_roleIsDpl;
		
		return isTrue;
	}	

	/**
	 * 
	 * @return
	 */
	public boolean isFixSrvc() {
		
		boolean isTrue = false;
		
		isTrue = m_roleIsDev;
		
		return isTrue;
	}	
	
	/**
	 * 
	 * @return
	 */
	public boolean isFixSuper( ) {
		
		boolean isTrue = false;
		
		isTrue = m_roleIsTst;
		isTrue |= m_roleIsDev;
		isTrue &= ( m_roleIsSup || m_roleIsAdm ) ;
		
		return isTrue;
	}	
	
	/**
	 * 
	 * @return
	 */
	public boolean isInYGrp( String p_DocUID ) {
		
		boolean isTrue = false;

		String uGroup;
	
		uGroup = getGroupForUser( m_Request.getRemoteUser() );
		
		isTrue = docIsInYourGroup( p_DocUID, uGroup );

		return isTrue;		
	}
	
	/**
	 * 
	 * @return
	 */
	public boolean isIssSuper( ) {
		
		boolean isTrue = false;
		
		isTrue = m_roleIsSup;
		isTrue |= m_roleIsAdm;
		
		return isTrue;
	}

	/**
	 * 
	 * @return
	 */
	public boolean isShpCoo( ) {
		
		boolean isTrue = false;
		
		isTrue = m_roleIsAdm;
		isTrue |= m_roleIsSup;
		isTrue |= m_roleIsCoo;
		isTrue &= m_roleIsDpl;
		
		return isTrue;
	}	
	
	/**
	 * 
	 * @return
	 */
	public boolean isShpSuper( ) {
		
		boolean isTrue = false;
		
		isTrue = m_roleIsDpl;
		isTrue &= ( m_roleIsSup || m_roleIsAdm ) ;
		
		return isTrue;
	}	
	
	
	/**
	 * 
	 * @return
	 */
	public boolean isShpSrvc( ) {
		
		boolean isTrue = false;
		
		isTrue = m_roleIsDpl;
		isTrue |= m_roleIsProd;
		isTrue |= m_roleIsSysTst;
		
		return isTrue;
	}	
	
	/**
	 * 
	 * @return
	 */
	public boolean isTRCoo( ) {
		
		boolean isTrue = false;
		
		isTrue = m_roleIsAdm;
		isTrue |= m_roleIsSup;
		isTrue |= m_roleIsCoo;
		isTrue &= m_roleIsDev;
		
		return isTrue;
	}
	
	/**
	 * 
	 * @return
	 */
	public boolean isTRSrvc( ) {
		
		boolean isTrue = false;
		
		isTrue = m_roleIsDev;
		isTrue |= m_roleIsBA;
		isTrue |= m_roleIsTst;
		isTrue |= m_roleIsDpl;		
		
		return isTrue;
	}	
	
	/**
	 * 
	 * @return
	 */
	public boolean isTRSuper( ) {
		
		boolean isTrue = false;
		
		isTrue = m_roleIsTst;
		isTrue |= m_roleIsDev;
		isTrue |= m_roleIsDpl;
		isTrue &= ( m_roleIsSup || m_roleIsAdm ) ;
		
		return isTrue;
	}
	
	/**
	 * 
	 * @return
	 */
	public boolean isTstCoo( ) {
		
		boolean isTrue = false;
		
		isTrue = m_roleIsAdm;
		isTrue |= m_roleIsSup;
		isTrue |= m_roleIsCoo;
		isTrue &= m_roleIsTst;
		
		isTrue |= m_roleIsTst;
		
		return isTrue;
	}
	
	/**
	 * 
	 * @return
	 */
	public boolean isTstSrvc( ) {
		
		boolean isTrue = false;
		
		isTrue = m_roleIsTst;
		isTrue |= m_roleIsDev;
		isTrue |= m_roleIsDpl;		
		
		return isTrue;
	}	
	
	/**
	 * 
	 * @return
	 */
	public boolean isTstSuper( ) {
		
		boolean isTrue = false;
		
		isTrue = m_roleIsSup;
		isTrue |= m_roleIsAdm;
		isTrue &= m_roleIsTst;
		
		return isTrue;
	}
	
	/**
	 * 
	 * @return
	 */
	public boolean isTRInYGrp( String p_DocUID ) {
		
		boolean isTrue = false;
	
		if( isTRSuper() ) {
	
			isTrue = true;
		}
		else {
	
			isTrue = isInYGrp( p_DocUID );
		}
		
		return isTrue;		
	}	
	
	/**
	 * 
	 * @return
	 */
	public boolean isYours( String p_DocUID ) {
		
		boolean isTrue = false;
		
		RsltString rAssignee;
		
		rAssignee = m_xDB.getAttrVal( p_DocUID, QNDefs.c_AttrAssignd  );

		if( ( m_user.compareTo( rAssignee.getString() ) == 0) ) {
	
			isTrue = true;
		}
		
		return isTrue;		
	}
}
