//---------------------------------------------------------
//QA Navigator SLMT Services Collection
//Copyright � 2009 Ronald D. Grindle
//---------------------------------------------------------

package RTtools;

import com.qanavigation.Basics.RsltString;
import com.qanavigation.QNservices.QNDefs;
import com.qanavigation.QNservices.UserTool;
import com.qanavigation.XMLDB.XMLDB;

/**
 * 
 * 
 *
 */
public class UserSrvcTool extends UserTool {
	
	public XMLDB m_xDB;

	/**
	 * 
	 * @param p_xDB
	 */
	public UserSrvcTool( XMLDB p_xDB ) {
		
		super( p_xDB.m_DB );
	}
	
	/**
	 * 
	 * @return
	 */
	public RsltString getAss4NewCR( ) {
		
		RsltString res = getSuper4CR( );
		
		return res;		
	}
	
	/**
	 * 
	 * @return
	 */
	public RsltString getAss4NewTR( String p_Prod, String p_Rel ) {
		
		RsltString res = getSuper4TR( p_Prod, p_Rel );
		
		return res;		
	}
	
	/**
	 * 
	 * @return
	 */
	public RsltString getAss4ReoCR( ) {
		
		RsltString res = getSuper4CR( );
		
		return res;		
	}
	
	/**
	 * 
	 * @return
	 */
	public RsltString getAss4ReoTR( String p_Prod, String p_Rel ) {
		
		RsltString res = getSuper4TR( p_Prod, p_Rel );
		
		return res;		
	}	
	
	/**
	 * Returns the name (user ID) of the first supervisor for CRs found.
	 * @return
	 */
	public RsltString getSuper4CR( ) {
		
		RsltString res = getDefaultByRole( QNDefs.c_RoleSuper, QNDefs.c_RoleDBA );
		
		// fall back to supervisor
		if( res.notOK() ) {
			
			res = getDefaultByRole( QNDefs.c_RoleSuper, QNDefs.c_RoleBA );
		}
		
		// fall back to supervisor
		if( res.notOK() ) {
			
			res = getByRole( QNDefs.c_RoleSuper );
		}

		return res;
	}
	
	/**
	 * Returns the name (user ID) of the first supervisor for Deployments found.
	 * @return
	 */
	public RsltString getSuper4Dpl( ) {
		
		RsltString res = getDefaultByRole( QNDefs.c_RoleSuper, QNDefs.c_RoleDDpl );
		
		// fall back to supervisor
		if( res.notOK() ) {
			
			res = getByRole( QNDefs.c_RoleSuper );
		}

		return res;
	}
	
	/**
	 * Returns the name (user ID) of the first supervisor for System Test found.
	 * @return
	 */
	public RsltString getSuper4Prod( ) {
		
		RsltString res = getDefaultByRole( QNDefs.c_RoleSuper, QNDefs.c_RoleDProd );
		
		// fall back to supervisor
		if( res.notOK() ) {
			
			res = getByRole( QNDefs.c_RoleSuper );
		}

		return res;
	}
	
	/**
	 * Returns the name (user ID) of the first supervisor for System Test found.
	 * @return
	 */
	public RsltString getSuper4SysTst( ) {
		
		RsltString res = getDefaultByRole( QNDefs.c_RoleSuper, QNDefs.c_RoleDSysTst );
		
		// fall back to supervisor
		if( res.notOK() ) {
			
			res = getByRole( QNDefs.c_RoleSuper );
		}

		return res;
	}
	
	/**
	 * Returns the name (user ID) of the first supervisor for issues found.
	 * @return
	 */
	public RsltString getSuper4TR( String p_Prod, String p_Rel ) {
		
		RsltString res = getDefaultByRoleProd( QNDefs.c_RoleSuper, QNDefs.c_RoleDDev, p_Prod, p_Rel );

		return res;
	}	
	
	/**
	 * 
	 * @param p_Author
	 * @param p_Rel
	 * @return
	 */
	public RsltString getAssgn4CRRej( String p_Author ) {

		RsltString rStr;
		
		rStr = getDefaultByRole( QNDefs.c_RoleSuper, QNDefs.c_RoleDBA  );
				
		return rStr;
	}
	
	/**
	 * 
	 * @param p_Author
	 * @param p_Rel
	 * @return
	 */
	public RsltString getAssgn4ShpRej( String p_Author ) {

		RsltString rStr;
		
		//rStr = getDefaultByRole( QNDefs.c_RoleSuper, QNDefs.c_RoleDDpl  );
		rStr = new RsltString( "" );
				
		return rStr;
	}	
	
	/**
	 * 
	 * @param p_Author
	 * @param p_Rel
	 * @return
	 */
	public RsltString getAssgn4TRRej( String p_Author, String p_Prod, String p_Rel ) {

		RsltString rStr;
		
		rStr = getDefaultByRoleProd( QNDefs.c_RoleSuper, QNDefs.c_RoleDDev, p_Prod, p_Rel );
				
		return rStr;
	}
	
	/**
	 * Falls back to first role, if criteria are not met.
	 * @param p_Role1
	 * @param p_Role2
	 * @param p_Rel
	 * @return
	 */
	public RsltString getDefaultByRoleProd( String p_Role1, String p_Def, String p_Appl, String p_Rel ) {

		RsltString rStr;
		
		rStr = getByRoleApplRel( p_Role1, p_Def, p_Appl, p_Rel );
		
//rStr.setOK();	
		// fall back to first role w/o release
		if( rStr.notOK() ) {
			
			rStr = getByRoleAppl( p_Role1, p_Def, p_Appl );
//rStr.appString( " fb1" );			
		}		
		
		// fall back to first role w/o product
		if( rStr.notOK() ) {
			
			rStr = getDefaultByRole( p_Role1, p_Def );
//rStr.appString( " fb2" );			
		}
		
		// fall back to first role
		if( rStr.notOK() ) {
			
			rStr = getByRole( p_Role1 );
//rStr.appString( " fb3" );			
		}	
		
		if( rStr.notOK() ) {
			
			rStr.addRsltAddFailInfo( "UserSrvcTool", "getDefaultByRoleProd", " for " + p_Role1 + ", " + p_Def + ", " + p_Appl + ", " + p_Rel, "" );
		}
				
		return rStr;
	}
	
}
