// QANav Report Tracker Copyright 2004 Ronald D. Grindle

import java.io.IOException;
import java.io.PrintWriter;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import RTObj.CRRepBld;
import RTObj.ShpDocBld;
import RTObj.TRRepBld;
import RTtools.QNDocMan;

import com.qanavigation.Basics.BTools;
import com.qanavigation.Basics.Rslt;
import com.qanavigation.Basics.Rslt2DArray;
import com.qanavigation.Basics.RsltString;
import com.qanavigation.Basics.SFormatter;
import com.qanavigation.QNservices.QNDBacc2;
import com.qanavigation.QNservices.QNDefs;
import com.qanavigation.QNservices.QNRscBundle;
import com.qanavigation.QNservices.SrvltReqTools;
import com.qanavigation.XMLBasics.RsltXMLNode;

/**
* Servlet services to do different kind updates on a report.
* See subroutines for details.
*/
public class UpdQNDoc extends HttpServlet {
	
	static final long serialVersionUID = 61940007;
	
	private QNDBacc2 m_dBAcc;
	private QNDocMan m_qnDm;
	private SrvltReqTools m_sTools;
	private QNRscBundle m_resBndl;

	//---------------------------------------------
	protected void service(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
		super.service( request, response );
	}

	//---------------------------------------------
	public void doGet(HttpServletRequest request, HttpServletResponse response) throws IOException, ServletException {
		handleReq( request, response );
	}

	//---------------------------------------------
	public void doPost(HttpServletRequest request, HttpServletResponse response) throws IOException, ServletException {
		handleReq( request, response );
	}

	//---------------------------------------------
	public void handleReq(HttpServletRequest request, HttpServletResponse response) throws IOException, ServletException {

		boolean notHandled = true;

		RsltString rStr = new RsltString();

		String dType;

		String QNA;
		String UID;

		response.setContentType("text/html");
		
		//reqEnc = request.getCharacterEncoding();
		//rUser = request.getRemoteUser();
		
		PrintWriter out = response.getWriter();
		
		m_resBndl = new QNRscBundle( "QNLabels", request.getLocale() );

		Rslt res = new Rslt( true );
		
		m_dBAcc = new QNDBacc2();
		
		res.checkRslt( m_dBAcc );

		m_sTools = new SrvltReqTools( this, request );  		
	
		UID = m_sTools.getStrVal( "UID" );
		
		QNA = m_sTools.getStrVal( "QNA" );
		
		//dateTime = BTools.getNowISODateTime();

		if( res.checkRslt( m_sTools ) ) {
			
			dType = m_sTools.getStrVal( "DocType" );

			m_qnDm = new QNDocMan( m_dBAcc.m_DB, dType );

			// add comment request ------------------------------	
			if( 0 == QNA.compareTo( "AddCmnct" ) ) {
	
				notHandled = false;
							
				rStr = AddCmnct( UID );
				
				res.checkRslt( rStr );
			}
			
			// add comment request ------------------------------	
			if( 0 == QNA.compareTo( "AddPR2CR" ) ) {
	
				notHandled = false;
							
				rStr = AddPR2CR( UID );
				
				res.checkRslt( rStr );
			}
			
			// Append reports 2 ship a list ------------------------------
			if( notHandled ) {
				
				if( 0 == QNA.compareTo( "App2ShpLst" ) ) {
					
					notHandled = false;
					
					rStr = App2ShpLst();
					
					res.checkRslt( rStr );					
				}
			}

			// set CR/PR status ------------------------------
			if( notHandled ) {
				
				if( 0 == QNA.compareTo( "AppFile" ) ) {
		
					notHandled = false;
					
					rStr = AppFile( UID, request );
					
					res.checkRslt( rStr );
				}
			}
			
			// assign ------------------------------
			if( notHandled ) {
				
				if( 0 == QNA.compareTo( "Assign" ) ) {
		
					notHandled = false;
					
					rStr = Assign( UID );
					
					res.checkRslt( rStr );
				}
			}

			// assign a list ------------------------------
			if( notHandled ) {
				
				if( 0 == QNA.compareTo( "AssignLst" ) ) {
		
					notHandled = false;
					
					rStr = AssignLst();
					
					res.checkRslt( rStr );
				}
			}
						
			// Close Technical Report ------------------------------
			if( notHandled ) {
				
				if( 0 == QNA.compareTo( "Close" ) ) {

					notHandled = false;

					rStr = Close( UID );
				
					res.checkRslt( rStr );
				}
			}
			
			// Delete Technical Report ------------------------------
			if( notHandled ) {
				
				if( 0 == QNA.compareTo( "Delete" ) ) {

					notHandled = false;

					rStr = Delete( UID );
				
					res.checkRslt( rStr );
				}
			}
			
			// delete a list of draft docs ------------------------------
			if( notHandled ) {
				
				if( 0 == QNA.compareTo( "DelPRLst" ) ) {

					notHandled = false;

					rStr = DelPRLst(  );
				
					res.checkRslt( rStr );
				}
			}
			
			// new shipment document ------------------------------
			// this is not really updating a document, candidate to move to a better place
			if( notHandled ) {
				
				if( 0 == QNA.compareTo( "NewShipDoc" ) ) {
		
					notHandled = false;
					
					rStr = NewShipDoc();
					
					res.checkRslt( rStr );
				}
			}

			// select Test System for Shipment ------------------------------
			if( notHandled ) {
				
				if( 0 == QNA.compareTo( "SelShpTSys" ) ) {
		
					notHandled = false;
					
					rStr = SelShpTSys( UID );
					
					res.checkRslt( rStr );
				}
			}
			
			// set CR/PR status ------------------------------
			if( notHandled ) {
				
				if( 0 == QNA.compareTo( "SetCR" ) ) {
		
					notHandled = false;
					
					rStr = SetCR( UID );
					
					res.checkRslt( rStr );
				}
			}

			// Set the external text block ------------------------------
			if( notHandled ) {
				
				if( 0 == QNA.compareTo( "SetEst" ) ) {
					
					notHandled = false;
					
					rStr = SetEst( UID );
					
					res.checkRslt( rStr );					
				}
			}
			
			// Set the external text block ------------------------------
			if( notHandled ) {
				
				if( 0 == QNA.compareTo( "SetExtTxt" ) ) {
					
					notHandled = false;
					
					rStr = SetExtTxt( UID );
					
					res.checkRslt( rStr );					
				}
			}
			
			// set problem status ------------------------------
			if( notHandled ) {
				
				if( 0 == QNA.compareTo( "SetFix" ) ) {
					
					notHandled = false;
					
					rStr = SetFix( UID );
					
					res.checkRslt( rStr );					
				}
			}
			
			// set CR/PR status ------------------------------
			if( notHandled ) {
				
				if( 0 == QNA.compareTo( "SetFixTst" ) ) {
		
					notHandled = false;
					
					rStr = SetFixTst( UID );
					
					res.checkRslt( rStr );
				}
			}
			
			// set CR/PR status ------------------------------
			if( notHandled ) {
				
				if( 0 == QNA.compareTo( "SetPrio" ) ) {
		
					notHandled = false;
					
					rStr = SetPrio( UID );
					
					res.checkRslt( rStr );
				}
			}							

			// set problem status ------------------------------
			if( notHandled ) {
				
				if( 0 == QNA.compareTo( "SetRStat" ) ) {
		
					notHandled = false;
					
					rStr = SetRStat( UID );
					
					res.checkRslt( rStr );
				}
			}
			
			// set problem status with status check ------------
			if( notHandled ) {
				
				if( 0 == QNA.compareTo( "SetRStatWChk" ) ) {
		
					notHandled = false;
					
					rStr = SetRStatWChk( UID );
					
					res.checkRslt( rStr );
				}
			}
			
			// set problem and fix status ---------------------------
			if( notHandled ) {
				
				if( 0 == QNA.compareTo( "SetShip" ) ) {
		
					notHandled = false;
					
					rStr = SetShip( UID );
					
					res.checkRslt( rStr );
				}
			}
			
			// ship a list ------------------------------
			if( notHandled ) {
				
				if( 0 == QNA.compareTo( "SetShipLst" ) ) {
		
					notHandled = false;
					
					rStr = SetShipLst(  );
					
					res.checkRslt( rStr );
				}
			}
			
			// submit a list of draft docs ------------------------------
			if( notHandled ) {
				
				if( 0 == QNA.compareTo( "SubPRLst" ) ) {
		
					notHandled = false;
					
					rStr = SubPRLst(  );
					
					res.checkRslt( rStr );
				}
			}	
			
			// change status of TR list ------------------------------
			if( notHandled ) {
				
				if( 0 == QNA.compareTo( "SetTRStatLst" ) ) {
		
					notHandled = false;
					
					rStr = SetTRStatLst();
					
					res.checkRslt( rStr );
				}
			}	
			
			// change status of TR list ------------------------------
			if( notHandled ) {
				
				if( 0 == QNA.compareTo( "UpdFix" ) ) {
		
					notHandled = false;
					
					rStr = UpdFix( UID );
					
					res.checkRslt( rStr );
				}
			}			
			
			// no such request ------------------------------
			if( notHandled ) {

				res.setInError( m_resBndl.getString( "errWrongQNAppl" ) );
			}
		}
//System.err.println( "res " + res.getRsltFinalMsg() );

		if( res.isOK() ) {
			
//rStr.appString( "<p>updqndoc</p>" );

			out.println( QNDefs.c_HTMLMsgMsgHead + rStr.getString() + "</p>" + QNDefs.c_HTMLMsgRepOKHead + "</p>");

			out.println( "<script type=\"text/javascript\">parent.notify( \"MissionOK\" );</script>" );
		}
		else {

			/*
			UserMailTool mt = new UserMailTool( dBAcc.m_DB );
			String mMsg = "An error occured: " + res.getRsltFinalMsg();
			subj = "QANav error at " + request.getRequestURL();
			
			String sender = m_resBndl.getString( "valSenderMail" );	
			String senderClear = m_resBndl.getString( "valSenderClear" );
			
			mt.mailToAdm( subj, mMsg, mMsg, sender, senderClear );
			*/

			String errMsg1 = m_resBndl.getString( "errTransxFailed" );
			String errMsg2 = SFormatter.format( m_resBndl.getString( "errReason" ), res.getRsltFinalMsg() );
			errMsg2 += " " + SFormatter.format( m_resBndl.getString( "errInitReason" ), res.getRsltInitialMsg() );
			String errMsg3 = m_resBndl.getString( "errAdminNotified" );

			SrvltReqTools.logErr( this, request, res );

			//ServletContext sc = getServletContext();
			String url = "/ErrMsg.jsp?";

			url += "Msg1=" + SrvltReqTools.encodeReqStr( errMsg1  );
			url += "&Msg2=" + SrvltReqTools.encodeReqStr( errMsg2  );
			url += "&Msg3=" + SrvltReqTools.encodeReqStr( errMsg3  );

			/* RequestDispatcher rd = sc.getRequestDispatcher( url );
			
			if( rd != null ) {
				
				rd.forward( request, response );
			}
			else { */
								
				out.println( QNDefs.c_HTMLMsgRepFailHead + errMsg1 + "</p>" );
				out.println( QNDefs.c_HTMLMsgMsgHead + errMsg2 + "</p>" );
				out.println( "<p>" + errMsg3 + "</p>" );
			//}
		}
		
//out.println( "<p>UpdQNDoc called for '" + QNA + "'" );		
		
		m_dBAcc.close();
	}
	
	/**
	 * Adds a communication 2 the report.
	 * Expected Parameters:
	 * Author: Author
	 * CmnctTitle: Titel for comment
	 * TxtCmnct: Comment
	 * ExtID: reference to an external ID (opt.)
	 * ExtDT: external DateTime (opt.)
	 * Stat: New Status
	 * UID: UID of the document
	 * 
	 * @param UID
	 * @return
	 */
	private RsltString AddCmnct( String UID ) {

		RsltString rStr = new RsltString( true );
		
		Rslt res;
		RsltString rVal;
		
		String docNum;
		String subj;
		String theUrl;
		
		String author = m_sTools.checkParam( "Author" );
		String title = m_sTools.checkParam( "CmnctTitle" );
		String txt = m_sTools.checkParam( "TxtCmnct" );
		String extID = m_sTools.getStrVal( "ExtID" );
		String extDT = m_sTools.getStrVal( "ExtDT" );		
		String stat = m_sTools.getStrVal( "Stat" );
		
		String msg = m_resBndl.getString( "msgCmmntAdd" );
		
		title = SFormatter.encodeHTML( title );
		txt = SFormatter.encodeHTML( txt );
		extID = SFormatter.encodeHTML( extID );
		extDT = SFormatter.encodeHTML( extDT );
		
		res = m_qnDm.addLogX( UID, author, title, txt, extID, extDT );
			
		if( rStr.checkRslt( res ) ) {
		
			theUrl = m_sTools.getUrl4DocView( UID, m_qnDm.getViewTag() );
		
			rVal = m_qnDm.hndlDocStat( UID, m_resBndl, stat, theUrl, author );
		
//System.err.println( "hndlDocStat " + rVal.getRsltFinalMsg() );
		
			if( rStr.checkRslt( rVal ) ) {
			
				msg += "</p><p>" + rVal.getString();
								
				rVal = m_qnDm.getDocNum( UID );
				docNum = rVal.getString();
				
				subj =  SFormatter.format( m_resBndl.getString( "msgCommAdTo" ), docNum );
				
				rVal = notifyUser( UID, author, subj, theUrl );
				
				if( rStr.checkRslt( rVal ) ) {
					
					rStr.setString( msg );
				}
			}	
		}
		
		if( rStr.notOK() ) {
			
			rStr.addRsltAddInfo( "'AddCmnct' failed." );
		}			
		
		return rStr;
	}
	
	/**
	 * Links a Technical Report to a CR Report.
	 * Expected Parameters:
	 * PRUID: UID of the TR
	 * PRTicket: sequence number of the TR
	 * PRTitle: Title of the TR
	 * PRStat: status of the TR
	 * UID: UID of the document
	 * 
	 * @param UID
	 * @return
	 */
	private RsltString AddPR2CR( String UID ) {
		
		RsltString rStr = new RsltString( true );
		
		Rslt res;
		
		String prUID, ticket, title, stat;
		
		CRRepBld rb = new CRRepBld( m_dBAcc.m_DB, m_sTools, QNDefs.c_RMFilePath );
		
		prUID = m_sTools.getStrVal( "PRUID" );
		ticket = m_sTools.getStrVal( "PRTicket" );
		title = m_sTools.getStrVal( "PRTitle" );
		stat = m_sTools.getStrVal( "PRStat" );
		
		res = rb.addPR( UID, prUID, ticket, title, stat );
		
		if( rStr.checkRslt( res ) ) {
			
			rStr.setString( m_resBndl.getString( "msgPRadded2CR" ) );
		}
		
		return rStr;		
	}
	
	// -----------------
	private RsltString App2ShpLst( ) {
		
		RsltString rStr = new RsltString( true );
		
		Rslt res;
		
		int i, x, k;
		
		RsltString solUID;
		
		RsltXMLNode sprNode;
		
		ShpDocBld sdb;
		
		RsltString shpDocUID;
						
		String aUID;
		String stat = m_sTools.checkParam( "Stat" );
		String author = m_sTools.checkParam( "Author" );
		String cStat = m_sTools.checkParam( "CurrStat" );
		String msg;
		String msg1 = "";
		String pName;
		String UID = m_sTools.checkParam( "Val1" );
		String val;
		
		k = 0;				
							
		RsltString rVal = m_sTools.getVal( "Lines" );

		if( rStr.checkRslt( rVal ) ){
		
			val = rVal.getString();
			
			x = Integer.parseInt( val );
			
//msg1 +=	"Lines: " + x + ". ";	
			
			sdb = m_qnDm.getNewShipDoc( m_sTools, QNDefs.c_RMFilePath );
			
			String shpRel = m_qnDm.m_xDB.getAttrVal( UID, QNDefs.c_AttrShipRel ).getString();
			String shpDate = m_qnDm.m_xDB.getAttrVal( UID, QNDefs.c_AttrDateTimeShip ).getString(); 

			shpDocUID = m_qnDm.m_xDB.getFirstUIDByParent( QNDefs.c_NodeShpLst, UID);
			
			if( rStr.checkRslt( shpDocUID ) ) {
				
				for( i = 0; i < x; ++i ) {
				
					pName = "Line" + i;

					rVal = m_sTools.getVal( pName );
					
					aUID =  rVal.getString();						

					if( aUID.length() > 0 ) {
						
//msg1 +=	"Line: " + pName + ". ";							

						msg = SFormatter.format( m_resBndl.getString( "msgFixIsSetTo" ), m_resBndl.getString( "valStat_" + stat ) );
						
						if( m_qnDm.docIsInStat( aUID, cStat ) ) {
						
							rVal = m_qnDm.setFixShp( aUID, cStat, stat, shpRel, shpDate, msg );
						
							// required for downward compatability, drop in 2010
							rVal = m_qnDm.setFixShp( aUID, QNDefs.c_StatR4Ship, stat, shpRel, shpDate, msg );								
							
							msg1 += rVal.getString();
											
							if( rStr.checkRslt( rVal ) ) {
												
								rVal = m_qnDm.hndlDocStat( aUID, m_resBndl, stat, "", author );
								
								if( rStr.checkRslt( rVal ) ) {
								
									msg1 += rVal.getString() + "<br>";
								}
							}
							
							if( rStr.isOK() ) {
								
								sprNode = new RsltXMLNode( QNDefs.c_NodeShpPRRef  );								
								
								res = sdb.bldSol( sprNode, aUID, stat );
								
								rStr.checkRslt( res );
								
								solUID = m_qnDm.add2SolDoc( shpDocUID.getString(), sprNode );
								
								rStr.checkRslt( solUID );
							}
							
							if( rStr.notOK() ) {
								
								i = x;
							}
							else {
								
								k++;
							}
						}
					}
				}
			}
		}
		
		if( rStr.isOK() ) {
			
			msg1 += rStr.getRsltFinalMsg();

			//msg1 += "Status is '" + RsltStatVal.label[ res.getRsltStatVal() ] + "'. ";					
			msg1 += SFormatter.format( m_resBndl.getString( "msgNDocProc" ), String.valueOf( k ) );
		
			rStr.setString( msg1 );
		}
		else {
			
			rStr.addRsltAddInfo( "'App2ShpLst' failed.");
		}
		
		return rStr;
	}							

	
	// -----------------
	private RsltString AppFile( String UID,  HttpServletRequest request ) {

		RsltString res;
		
		RsltString rVal;
		
		String author;
		String docNum;
		String msg = "";
		String subj;
		String title;
		String txt;
		String theUrl;
		
		TRRepBld prb = new TRRepBld( m_dBAcc.m_DB, m_sTools, QNDefs.c_RMFilePath );
		
		String dateTime = BTools.getNowISODateTimeSec();
		String rUser = request.getRemoteUser();
		String reqEnc = request.getCharacterEncoding();
		
		String extID = m_sTools.getStrVal( "ExtID" );
		String extDT = m_sTools.getStrVal( "ExtDT" );
		
		extID = SFormatter.encodeHTML( extID );
		extDT = SFormatter.encodeHTML( extDT );
		
		res = prb.addAppFile( UID, rUser, "FileDesc", reqEnc, dateTime, extID, extDT );
		
		if( res.isOK() ) {
			
			author = m_sTools.checkParam( "Author" );
			author = SFormatter.encodeHTML( author );
			title = m_resBndl.getString( "lblFileAppd" );
			
			theUrl = m_sTools.getUrl4DocView( UID, m_qnDm.getViewTag() );
			
			txt =  SFormatter.format( m_resBndl.getString( "msgFileXAppd" ), SFormatter.encodeHTML( res.getString() ) );

			msg = m_resBndl.getString( "msgFileSuccAppd" );
			
			m_qnDm.addLogX( UID, author, title, txt, "", "" );
			
			rVal = m_qnDm.getDocNum( UID );
			docNum = rVal.getString();
			
			subj =  SFormatter.format( m_resBndl.getString( "lblFileAdToRep" ), docNum );
			
			rVal = notifyUser( UID, author, subj, theUrl );
			
			if( res.checkRslt( rVal ) ) {
				
				res.setString( msg );
			}
		}
		
		return res;		
	}
	
	// -----------------
	private RsltString Assign( String UID ) {

		RsltString res = new RsltString( true );
		
		boolean withMail = true;

		String ass = m_sTools.checkParam( "Assignee" );
		RsltString rStat = m_sTools.getVal( "Stat" );
		String user = m_sTools.checkParam( "User" );
		
		if( ass.compareTo( user ) == 0 ) {
			
			withMail = false;
		}
		
		String theUrl = m_sTools. getUrl4DocView( UID, m_qnDm.getViewTag() );
		
		String msg = SFormatter.format( m_resBndl.getString( "msgInstAsgnToBy" ), ass , user ) ;
		
		RsltString rVal = m_qnDm.assignTo(  m_resBndl, theUrl, UID, ass, msg, withMail, true );

		if( res.checkRslt( rVal ) ) { 
			
			rVal = m_qnDm.hndlDocStat( UID, m_resBndl, rStat.getString(), theUrl, user );
			
			res.checkRslt( rVal );
		}

		if( res.isOK() ) {
			
			res.setString( SFormatter.format( m_resBndl.getString( "msgRepAssgnTo" ), ass ) );
		}

		return res;
	}   
	
	// -----------------
	private RsltString AssignLst( ) {
		
		RsltString res = new RsltString( true );
		
		boolean withMail = true;
		
		int i, k, x;
		
		RsltString rVal;
		
		String aUID;
		String msg;
		String pName;
		String val;

		String ass = m_sTools.checkParam( "Val1" );
		RsltString rStat = m_sTools.getVal( "Stat" );
		String user = m_sTools.checkParam( "Author" );
		
		if( ass.compareTo( user ) == 0 ) {
			
			withMail = false;
		}

		rVal = m_sTools.getVal( "Lines" );
		
		if( res.checkRslt( rVal ) ){
		
			val = rVal.getString();
			
			k = 0;

			x = Integer.parseInt( val );
			
//msg1 += val + " lines. <br>";

			for( i = 0; i < x; ++i ) {

				pName = "Line" + i;
				
//msg1 += "Looking for '" + pName + "'<br>";						

				rVal = m_sTools.getVal( pName );
				aUID =  rVal.getString();

				if( aUID.length() > 0 ) {
					
//msg1 += "" + pName + " found <br>";							
					
					k++;
		
					String theUrl = m_sTools.getUrl4DocView( aUID, m_qnDm.getViewTag() );
		
					msg = SFormatter.format( m_resBndl.getString( "msgInstAsgnToBy" ), ass , user ) ;
		
					rVal = m_qnDm.assignTo( m_resBndl, theUrl, aUID, ass, msg, withMail, true );
		
					if( res.checkRslt( rVal ) ) {
			
						rVal = m_qnDm.hndlDocStat( aUID, m_resBndl, rStat.getString(), theUrl, user );
					}
				}
			}
			
			msg = SFormatter.format( m_resBndl.getString( "msgRepAssgnTo" ), ass ) + " (" + k + ")";
			
			res.setString( msg );
		}
		
		if( res.notOK() ) {
			
			res.addRsltAddInfo( "'AssignLst' failed.");
		}
		
		return res;
	}
	
	// -----------------
	private RsltString Close( String UID ) {

		RsltString rStr = new RsltString( true );
		
		RsltString rVal;
		
		String msg = m_resBndl.getString( "msgRepClosed" );
		String user = m_sTools.checkParam( "User" );
	
		if( rStr.checkRslt( m_qnDm ) ) {
	
			String theUrl = m_sTools.getUrl4DocView( UID, m_qnDm.getViewTag() );
			
			rVal = m_qnDm.hndlDocStat( UID, m_resBndl, "cl", theUrl, user );
			
			if( rStr.checkRslt( rVal ) ) {
	
				msg += "</p><p>" + rVal.getString() + "<p>";
				
				rStr.setString( msg );
			}
		}
		
		return rStr;
	}
	
	// -----------------
	private RsltString Delete( String UID ) {
		
		RsltString rStr = new RsltString( true );
		
		Rslt res;
		
		// we'll need this for the sys log
		//String user = m_sTools.checkParam( "User" );	
	
		/*
		if( !request.isUserInRole( "adm" ) ) {
	
			res.setInError( "You are not authorized to execute this task." );
		} */
	
		if( rStr.checkRslt( m_qnDm ) ) {
	
			res = m_qnDm.delete( UID );

			if( rStr.checkRslt( res ) ) {
		
				rStr.setString( m_resBndl.getString( "msgDocDelted" ) );
			}
		}
		
		return rStr;
	}	
	
	// delete a list of draft docs ------------------------------
	private RsltString DelPRLst( ) {

		int i, k, x;
		
		RsltString rStr = new RsltString( true );
		
		String pName;
		String val;
		
		RsltString rVal;
		
		String aUID;		
		String cStat;

		//String user;
	
		
		cStat = m_sTools.checkParam( "CurrStat" );				

		//user = m_sTools.checkParam( "Author" );

		rVal = m_sTools.getVal( "Lines" );
		
		if( rStr.checkRslt( rVal ) ){
		
			val = rVal.getString();
			
			k = 0;

			x = Integer.parseInt( val );

			for( i = 0; i < x; ++i ) {

				pName = "Line" + i;

				rVal = m_sTools.getVal( pName );
				aUID =  rVal.getString();

				if( aUID.length() > 0 ) {
					
					if( m_qnDm.docIsInStat(  aUID, cStat ) ) {							
					
						k++;
			
						if( rStr.checkRslt( rVal ) ) {
				
							m_qnDm.delete( aUID );
						}
					}
				}
			}	
			
			rStr.setString( SFormatter.format( m_resBndl.getString( "msgNDocProc" ), String.valueOf( k ) ) );						
		}
		
		return rStr;
	}
	
	/**
	 * Create a new ship doc
	 * @return
	 */
	private RsltString NewShipDoc() {
		
		// Does not really update a document. Move to better place.
		RsltString res = new RsltString( true );
		
		RsltString rUid;
		
		ShpDocBld sdb;
	
		String msg = "";
						
		String author = m_sTools.checkParam( "Author" );
		String shpRel = m_sTools.checkParam( "Val1" );
		String shpDate = m_sTools.checkParam( "Val2" );
		String appl = m_sTools.checkParam( "Val3" );
		String cmnt = m_sTools.getVal( "Val4" ).getString();
	
		sdb = m_qnDm.createShipDoc( m_sTools, QNDefs.c_RMFilePath, author, appl, shpRel, shpDate, cmnt );

		rUid = sdb.save();
		
		res.checkRslt( rUid );

		if( res.notOK() ) {
			
			msg = res.getRsltFinalMsg();
		}
		else {
		
			//msg1 += "Status is '" + RsltStatVal.label[ res.getRsltStatVal() ] + "'. ";					
			msg = m_resBndl.getString( "msgNewDoc" );
		}
		
		if( res.notOK() ) {
			
			res.addRsltAddInfo( "'NewShipDoc()' failed." );
		}
		
		res.setString( msg );
		
		return res;
	}		
	
	// -----------------
	private RsltString notifyUser( String UID, String author, String subj, String URL ) {
		
		RsltString rStr = new RsltString( true );
		
		//String docNum;
		String hMsg;
		String pMsg;
		String owner;
		String title;
		
		RsltString rVal = m_qnDm.getOwner( UID );
		
		owner = rVal.getString();
		
		if( owner.length() > 0 ) {
		
			if( rStr.checkRslt( rVal ) ) {
				
				if( author.compareTo( owner ) != 0 ) {
					
					rVal = m_qnDm.getTitle( UID );
					title = rVal.getString();
					
					String prl = m_resBndl.getString( "msgPlsRefLnk" ) ;
					
					hMsg = "<p>" + subj + "</p>";
					hMsg += "<p>" + prl + "</p>";
					hMsg += "<p><a href=\"" + URL + "\">" + title + "</a></p>";
	
					pMsg = subj;
					pMsg += "\n" + prl;
					pMsg += "\n" + URL + " (" + title + ")";
						
					rStr = m_qnDm.mailToUser( m_resBndl, owner, subj, hMsg, pMsg  );
				}
			}
		}
		
		if( rStr.notOK() ) {
			
			rStr.addRsltAddInfo( "notifyUser(...) failed." );
		}
		
		return rStr;
	}
	
	// -----------------
	private RsltString SelShpTSys( String UID ) {
	
		RsltString res = new RsltString( true );
		
		String author = m_sTools.checkParam( "Author" );
		String stat = m_sTools.checkParam( "Stat" );
		String tSys = m_sTools.checkParam( "TSys" );

		String msg = SFormatter.format( m_resBndl.getString( "msgShpTSysSel" ), tSys );

		res.checkRslt( m_qnDm.setTSys( UID, tSys, msg ) );
		
		if( res.isOK() ) {
			
			if( m_qnDm.docIsInStat( UID, QNDefs.c_StatR4Dpl ) ) {
			
				res = m_qnDm.hndlDocStat( UID, m_resBndl, stat, "", author );
			}
			else {
				
				res.setString( msg );
			}
			
			
		}
		
		return res;		
	}

	// -----------------
	private RsltString SetCR( String UID ) {
		
		RsltString msg = new RsltString( true );
		
		String isCR = m_sTools.checkParam( "dlIsCR" );
		String cRNum = m_sTools.checkParam( "dlCRNum" );

		if( msg.checkRslt( m_qnDm ) ) {

			m_qnDm.setCRX( UID, isCR, cRNum );				
		}

		if( msg.checkRslt( m_qnDm ) ) {
		
			msg.setString( m_resBndl.getString( "msgCRSet" ) );
		}
		
		return msg;
	}

	// ----------------
	private RsltString SetEst( String UID ) {
		
		RsltString res = new RsltString( true );
		
		String stat = m_sTools.checkParam( "Stat" );
		String author = m_sTools.checkParam( "Author" );
		String estDate = m_sTools.checkParam( "EstDate" );

		String msg = SFormatter.format( m_resBndl.getString( "msgEstSetTo" ), estDate );

		res.checkRslt( m_qnDm.setEstX( UID, estDate, msg ) );
		
		if( res.isOK() ) {
			
			if( m_qnDm.docIsInStat( UID, QNDefs.c_StatEval ) ) {
			
				res = m_qnDm.hndlDocStat( UID, m_resBndl, stat, "", author );
			}
			else {
				
				res.setString( msg );
			}
		}
		
		return res;
	}
	
	// ----------------
	private RsltString SetExtTxt( String UID ) {

		RsltString rStr = new RsltString( true );
		
		Rslt res;
		RsltString rVal;

		String docNum;
		String subj;
		String theUrl;

		String txt = m_sTools.getStrVal( "Txt" );
		String extID = m_sTools.getStrVal( "ExtID" );
		String extDT = m_sTools.getStrVal( "ExtDT" );
		
		String user = m_sTools.m_Req.getRemoteUser();

		//txt = SFormatter.encodeHTML( txt );
		//extID = SFormatter.encodeHTML( extID );
		//extDT = SFormatter.encodeHTML( extDT );
		
		res = m_qnDm.setExtTxt( UID, txt, extID, extDT );
			
		if( rStr.checkRslt( res ) ) {
		
			theUrl = m_sTools.getUrl4DocView( UID, m_qnDm.getViewTag() );
								
			rVal = m_qnDm.getDocNum( UID );
			docNum = rVal.getString();
				
			subj =  SFormatter.format( m_resBndl.getString( "msgExtTxt" ), docNum );
				
			rVal = notifyUser( UID, user, subj, theUrl );
			
			rStr.checkRslt( rVal );
				
			if( rVal.getString().length() > 0 ) {
					
				rStr.setString( rVal.getString() );
			}
			else {

				rStr.setString( subj );
			}
		}
		
		if( rStr.notOK() ) {
			
			rStr.addRsltAddInfo( "'SetExtTxt' failed." );
		}			
		
		return rStr;
	}
	
	// -----------------
	private RsltString SetFix( String UID ) {	
		
		RsltString rStr = new RsltString( true );
		
		int i, x;
		
		RsltString rUid;
		RsltString rVal;
				
		String author;
		String branch;
		String count;
		String cmnt;
		String date;
		String fAuth;
		String file;
		String fixDesc;
		String fixImp;
		String fixTstReq;
		String lbl;
		String path;
		String pName;
		String rel;
		String sect;
		String stat;				
		String val;

		String[] fixDat;
		
		stat = m_sTools.checkParam( "Stat" );
		author = m_sTools.checkParam( "Author" );
		fixDesc = m_sTools.checkParam( "FixDesc" );
		fixTstReq = m_sTools.checkParam( "FixTstReq" );
		fixImp = m_sTools.checkParam( "FixImp" );
		
		//fixLst = m_sTools.checkParam( "FixLst" );
		
		Rslt2DArray fixLst = new Rslt2DArray();

		count = m_sTools.getStrVal( "FixCount" );

		x = Integer.parseInt( count );

		for( i = 0; i < x; ++i ) {

			pName = "FixFile" + i;
			rVal = m_sTools.getVal( pName );
			file = rVal.getString();

			if( file.length() > 0 ) {
				
				/* DateTime, Name, Path, Rel, SrcSrv */
				
				pName = "FixPath" + i;
				rVal = m_sTools.getVal( pName );
				path = rVal.getString();
				
				pName = "FixBranch" + i;
				rVal = m_sTools.getVal( pName );
				branch = rVal.getString();							
				
				pName = "FixLbl" + i;
				rVal = m_sTools.getVal( pName );
				lbl = rVal.getString();						
				
				pName = "FixDate" + i;
				rVal = m_sTools.getVal( pName );
				date = rVal.getString();
				
				pName = "FixTime" + i;
				rVal = m_sTools.getVal( pName );
				
				val = rVal.getString();
				
				if( val.length() > 0 ) {
				
					date += "T" + val;
				}	

				pName = "FixAuth" + i;
				rVal = m_sTools.getVal( pName );
				fAuth = rVal.getString();
				
				pName = "FixRel" + i;
				rVal = m_sTools.getVal( pName );
				rel = rVal.getString();
				
				pName = "FixSect" + i;
				rVal = m_sTools.getVal( pName );
				sect = rVal.getString();
				
				pName = "FixCmnt" + i;
				rVal = m_sTools.getVal( pName );
				cmnt = rVal.getString();			
				
				fixDat = new String[]{ fAuth, branch, cmnt, date, lbl, file, path, rel, sect, "" };				
				
				fixLst.add( fixDat );						
			}
		}				

		rUid = m_qnDm.createFinalFixDoc( UID, m_resBndl, author, fixDesc, fixImp, fixTstReq, fixLst );
		
		if( rStr.checkRslt( rUid ) ) {
			
			rVal = m_qnDm.hndlDocStat( UID, m_resBndl, stat, "", author );
			
			if( rStr.checkRslt( rVal ) ) {
			
				rStr.setString( rVal.getString() );
				
//msg1 += " createFinalFixDoc: " + rUid.getRsltFinalMsg();
//msg1 += " Status: " +  RsltStatVal.label[ rUid.getRsltStatVal() ];
			}
		}
		
		return rStr;
	}	
	
	
	// -----------------
	private RsltString SetFixTst( String UID ) {
		
		RsltString msg = new RsltString( true );	

		String val1 = m_sTools.checkParam( "FixTstDate" );
		String val2 = m_sTools.checkParam( "FixTstSys" );

		msg.checkRslt( m_qnDm.setFixTst( UID, val1, val2 ) );				

		if( msg.isOK() ) {
		
			//msg.setString( m_resBndl.getString( "msgFixTstSet" ) + "UID " + UID + " FixTstDate: " + val1 );
			msg.setString( m_resBndl.getString( "msgFixTstSet" ) );			
		}
		
//msg.appString( m_resBndl.getString( "msgFixTstSet" ) + "UID " + UID + " FixTstDate: " + val1 );		

		return msg;
	}
	
	// -----------------
	private RsltString SetPrio( String UID ) {	
		
		RsltString rStr = new RsltString( true );
		
		Rslt res;
		
		String prio;
		String user;
		String msg;	

		prio = m_sTools.checkParam( "Prio" );
		user = m_sTools.checkParam( "User" );

		if( rStr.checkRslt( m_qnDm ) ) {
			
			msg = SFormatter.format( m_resBndl.getString( "msgPrioSetToBy" ), m_resBndl.getString( "valPrio_" + prio ), user );

			res = m_qnDm.setPrioX( UID, prio, msg );
			
			if( rStr.checkRslt( res ) ) {

		
				rStr.setString( SFormatter.format( m_resBndl.getString( "msgPrioSet" ), m_resBndl.getString( "valPrio_" + prio ) ) );
			}
			
		//msg1 = SFormatter.format( m_resBndl.getString( "msgPrioSet" ), prio );
		}
		
		return rStr;
	}
	
	// ------------------------------
	private RsltString SetRStat( String UID ) {

		RsltString res;
		
		String stat = m_sTools.checkParam( "Stat" );
		String user = m_sTools.checkParam( "User" );
		
		String url = m_sTools.getUrl4DocView( UID, m_qnDm.getViewTag() );

		res = m_qnDm.hndlDocStat( UID, m_resBndl, stat, url, user );
		
//res.appString( " SetRStat" );
		return res;
	}	
	
	/**
	 * Sets the status of a report, with a check and a message.
	 * Expected Parameters:
	 * ChkStat: list of possible status. If the report is not in the desired status, the new status is not set.
	 * Msg: message for change.
	 * Stat: desired status
	 * User: user sending the request
	 * UID: UID of the document
	 * 
	 * @param UID
	 * @return
	 */
	private RsltString SetRStatWChk( String UID ) {

		RsltString rStr;
		RsltString cStat;
		
		String chkStat = m_sTools.checkParam( "ChkStat" );
		String msg = m_sTools.checkParam( "Msg" );
		String stat = m_sTools.checkParam( "Stat" );
		String user = m_sTools.checkParam( "User" );
		
		String url = m_sTools.getUrl4DocView( UID, m_qnDm.getViewTag() );
		
		cStat = m_qnDm.getDocStat( UID );
		
		if( chkStat.indexOf( cStat.getString() ) < 0 ) {
			
			rStr = new RsltString();
			rStr.setInError( "Document not in required status ('" + chkStat + "'." );
		}
		else {
	
			String title = SFormatter.format( m_resBndl.getString( "msgStatSet" ), stat );
			
			rStr = m_qnDm.hndlDocStat( UID, m_resBndl, stat, url, user );
			
			rStr.checkRslt( m_qnDm.addLog( UID, user, title, msg ) );
			
			//res.checkRslt( m_qnDm.appProcLogX( UID, msg ) );
		}
		return rStr;
	}
	
	/**
	 * Ship a single Ticket (inactive)
	 * @param UID
	 * @return
	 */
	private RsltString SetShip( String UID ) {
		
		RsltString res;
		
		String stat = m_sTools.checkParam( "Stat" );
		String author = m_sTools.checkParam( "Author" );
		String cStat = m_sTools.checkParam( "CurrStat" );
		String shpRel = m_sTools.checkParam( "Release" );
		String shpDate = m_sTools.checkParam( "ShipDate" );

		String msg = SFormatter.format( m_resBndl.getString( "msgFixIsSetTo" ), m_resBndl.getString( "valStat_" + stat ) );

		res = m_qnDm.setFixShp( UID, cStat, stat, shpRel, shpDate, msg );
		
		// required for downward compatibility. Drop in 2010
		res = m_qnDm.setFixShp( UID, QNDefs.c_StatFixd, stat, shpRel, shpDate, msg );
		
		if( res.isOK() ) {
			
			res = m_qnDm.hndlDocStat( UID, m_resBndl, stat, "", author );					
		}
		
		return res;
	}	
	
	/**
	 * Ship a list of TR
	 * @return
	 */
	private RsltString SetShipLst() {
		
		RsltString res = new RsltString( true );
		
		int i, k, x;
		
		RsltString rUid;
		
		ShpDocBld sdb;
		
		String msg;
		String msg1 = "";
		String pName;
		String val;
		String aUID;
								
		String stat = m_sTools.checkParam( "Stat" );
		String author = m_sTools.checkParam( "Author" );
		String cStat = m_sTools.checkParam( "CurrStat" );
		String shpRel = m_sTools.checkParam( "Val1" );
		String shpDate = m_sTools.checkParam( "Val2" );
		String appl = m_sTools.checkParam( "Val3" );
		String cmnt = m_sTools.getVal( "Val4" ).getString();		
		
		msg = SFormatter.format( m_resBndl.getString( "msgFixIsSetTo" ), m_resBndl.getString( "valStat_" + stat ) );
			
		RsltString rVal = m_sTools.getVal( "Lines" );
		
		if( res.checkRslt( rVal ) ){
		
			val = rVal.getString();
			
			k = 0;

			x = Integer.parseInt( val );
			
//msg1 +=	"Lines: " + x + ". ";	
			
			sdb = m_qnDm.createShipDoc( m_sTools, QNDefs.c_RMFilePath, author, appl, shpRel, shpDate, cmnt );
			
			for( i = 0; i < x; ++i ) {

				pName = "Line" + i;

				rVal = m_sTools.getVal( pName );
				
				aUID =  rVal.getString();						

				if( aUID.length() > 0 ) {
					
//msg1 +=	"Line: " + pName + ". ";							
					
					k++;
					
					if( m_qnDm.docIsInStat(  aUID, cStat ) ) {
					
						rVal = m_qnDm.setFixShp( aUID, cStat, stat, shpRel, shpDate, msg );

						// required for downward compatibility. Drop in 2010
						rVal = m_qnDm.setFixShp( aUID, QNDefs.c_StatFixd, stat, shpRel, shpDate, msg );
						
						msg1 += rVal.getString();
										
						if( res.checkRslt( rVal ) ) {
											
							rVal = m_qnDm.hndlDocStat( aUID, m_resBndl, stat, "", author );
							
							if( res.checkRslt( rVal ) ) {
							
								//msg1 += rVal.getString() + "<br>";
							}
						}
						
						if( res.isOK() ) {
							
							res.setRsltStat( sdb.appSol( aUID, stat ) );
						}
					}
				}
			}
			
			if( res.isOK() ) {					
			
				rUid = sdb.save();
				
				res.checkRslt(  rUid );
			}
			
			if( res.notOK() ) {
				
				msg1 += res.getRsltFinalMsg();
			}
			else {
			
				//msg1 += "Status is '" + RsltStatVal.label[ res.getRsltStatVal() ] + "'. ";					
				msg1 += SFormatter.format( m_resBndl.getString( "msgNDocProc" ), String.valueOf( k ) );
				
				res.setString( msg1 );
			}
		}
		
		if( res.notOK() ) {
			
			res.addRsltAddInfo( "'SetShipLst()' failed." );
		}			
		
		return res;
	}	
	
	// -----------------
	private RsltString SubPRLst( ) {	
		
		RsltString rStr = new RsltString( true );
		
		int i, k, x;

		Rslt res;
		RsltString rVal;
		
		String user;
		String val;
		String pName;	
		
		String aUID;				
		String cStat;		
		
		cStat = m_sTools.checkParam( "CurrStat" );				

		user = m_sTools.checkParam( "Author" );

		rVal = m_sTools.getVal( "Lines" );
		
		if( rStr.checkRslt( rVal ) ){
		
			val = rVal.getString();
			
			k = 0;

			x = Integer.parseInt( val );
			
//msg1 += val + " lines. <br>";

			for( i = 0; i < x; ++i ) {

				pName = "Line" + i;
				
//msg1 += "Looking for '" + pName + "'<br>";						

				rVal = m_sTools.getVal( pName );
				aUID =  rVal.getString();

				if( aUID.length() > 0 ) {
					
//msg1 += "" + pName + " found <br>";	
//msg1 += "Check " + aUID + " for '" + cStat + "' <br>";		
					
					if( m_qnDm.docIsInStat(  aUID, cStat ) ) {							
					
						k++;
			
						if( rStr.checkRslt( rVal ) ) {
				
							res = m_qnDm.submitDoc( aUID, m_resBndl, user );
						}
					}
				}
			}
			
			rStr.setString( SFormatter.format( m_resBndl.getString( "msgNDocProc" ), String.valueOf( k ) ) );						
		}
		
		return rStr;		
	}
	
	// ----------------------------
	private RsltString SetTRStatLst() {
		
		RsltString res = new RsltString( true );
		
		int i, k, x;
		
		Rslt aRes;
		
		String msg;
		String msg1 = "";
		String pName;
		String val;
		String aUID;
								
		String stat = m_sTools.checkParam( "Stat" );
		String author = m_sTools.checkParam( "Author" );
		String cStat = m_sTools.checkParam( "CurrStat" );
			
		RsltString rVal = m_sTools.getVal( "Lines" );
		
		msg = SFormatter.format( m_resBndl.getString( "msgFixIsSetTo" ), m_resBndl.getString( "valStat_" + stat ) );
		
		if( res.checkRslt( rVal ) ){
		
			val = rVal.getString();
			
			k = 0;

			x = Integer.parseInt( val );
			
//msg1 +=	"Lines: " + x + ". ";	

			for( i = 0; i < x; ++i ) {

				pName = "Line" + i;

				rVal = m_sTools.getVal( pName );
				
				aUID =  rVal.getString();						

				if( aUID.length() > 0 ) {
					
//msg1 +=	"Line: " + pName + ". ";							
					
					k++;
					
					if( m_qnDm.docIsInStat( aUID, cStat ) ) {
					
						aRes = m_qnDm.setFixStatX( aUID, cStat, stat, msg);
										
						if( aRes.isOK() ) {
											
							rVal = m_qnDm.hndlDocStat( aUID, m_resBndl, stat, "", author );
						}
					}
				}
			}
			
			if( res.notOK() ) {
				
				msg1 += res.getRsltFinalMsg();
			}
			else {
			
				//msg1 += "Status is '" + RsltStatVal.label[ res.getRsltStatVal() ] + "'. ";					
				msg1 += SFormatter.format( m_resBndl.getString( "msgNDocProc" ), String.valueOf( k ) );
				
				res.setString( msg1 );
			}
		}
		
		if( res.notOK() ) {
			
			res.addRsltAddInfo( "'SetStatLst()' failed." );
		}			
		
		return res;
	}	
	

	// -----------------
	private RsltString UpdFix( String UID ) {	
		
		RsltString rStr = new RsltString( true );
		Rslt res;
		
		int i, x;
		
		RsltString rVal;
				
		String author;
		String branch;
		String count;
		String cmnt;
		String date;
		String fAuth;
		String file;
		String fixDesc;
		String fixImp;
		String fixTstReq;
		String lbl;
		String path;
		String pName;
		String rel;
		String sect;
		String val;

		String[] fixDat;
		
		author = m_sTools.checkParam( "Author" );
		fixDesc = m_sTools.checkParam( "FixDesc" );
		fixTstReq = m_sTools.checkParam( "FixTstReq" );
		fixImp = m_sTools.checkParam( "FixImp" );
		
		//fixLst = m_sTools.checkParam( "FixLst" );
		
		Rslt2DArray fixLst = new Rslt2DArray();

		count = m_sTools.getStrVal( "FixCount" );

		x = Integer.parseInt( count );

		for( i = 0; i < x; ++i ) {

			pName = "FixFile" + i;
			rVal = m_sTools.getVal( pName );
			file = rVal.getString();

			if( file.length() > 0 ) {
				
				/* DateTime, Name, Path, Rel, SrcSrv */
				
				pName = "FixPath" + i;
				rVal = m_sTools.getVal( pName );
				path = rVal.getString();
				
				pName = "FixBranch" + i;
				rVal = m_sTools.getVal( pName );
				branch = rVal.getString();							
				
				pName = "FixLbl" + i;
				rVal = m_sTools.getVal( pName );
				lbl = rVal.getString();						
				
				pName = "FixDate" + i;
				rVal = m_sTools.getVal( pName );
				date = rVal.getString();
				
				pName = "FixTime" + i;
				rVal = m_sTools.getVal( pName );
				
				val = rVal.getString();
				
				if( val.length() > 0 ) {
				
					date += "T" + val;
				}	

				pName = "FixAuth" + i;
				rVal = m_sTools.getVal( pName );
				fAuth = rVal.getString();
				
				pName = "FixRel" + i;
				rVal = m_sTools.getVal( pName );
				rel = rVal.getString();
				
				pName = "FixSect" + i;
				rVal = m_sTools.getVal( pName );
				sect = rVal.getString();
				
				pName = "FixCmnt" + i;
				rVal = m_sTools.getVal( pName );
				cmnt = rVal.getString();			
				
				fixDat = new String[]{ fAuth, branch, cmnt, date, lbl, file, path, rel, sect, "" };				
				
				fixLst.add( fixDat );						
			}
		}

		rStr.checkRslt( m_qnDm.updateFixDoc( UID, m_resBndl, author, fixDesc, fixImp, fixTstReq, fixLst ) );

		if( rStr.isOK() ) {
			
			rStr.setString( m_resBndl.getString( "msgFixUpdated" ));
		}
		else {
			
			rStr.addRsltAddFailInfo( "UpdQNDoc", "UpdFix", "", "" );
		}
		
		return rStr;
	}	

}
