<?xml version='1.0'?>
<!-- Stylesheet for a Fix Report -->

<!DOCTYPE stylesheet [

<!ENTITY nbsp    "&#160;" >
<!ENTITY iexcl   "&#161;" >
<!ENTITY cent    "&#162;" >
<!ENTITY pound   "&#163;" >
<!ENTITY curren  "&#164;" >
<!ENTITY yen     "&#165;" >
<!ENTITY brvbar  "&#166;" >
<!ENTITY sect    "&#167;" >
<!ENTITY uml     "&#168;" >
<!ENTITY copy    "&#169;" >
<!ENTITY ordf    "&#170;" >
<!ENTITY laquo   "&#171;" >
<!ENTITY not     "&#172;" >
<!ENTITY shy     "&#173;" >
<!ENTITY reg     "&#174;" >
<!ENTITY macr    "&#175;" >
<!ENTITY deg     "&#176;" >
<!ENTITY plusmn  "&#177;" >
<!ENTITY sup2    "&#178;" >
<!ENTITY sup3    "&#179;" >
<!ENTITY acute   "&#180;" >
<!ENTITY micro   "&#181;" >
<!ENTITY para    "&#182;" >
<!ENTITY middot  "&#183;" >
<!ENTITY cedil   "&#184;" >
<!ENTITY sup1    "&#185;" >
<!ENTITY ordm    "&#186;" >
<!ENTITY raquo   "&#187;" >
<!ENTITY frac14  "&#188;" >
<!ENTITY frac12  "&#189;" >
<!ENTITY frac34  "&#190;" >
<!ENTITY iquest  "&#191;" >
<!ENTITY Agrave  "&#192;" >
<!ENTITY Aacute  "&#193;" >
<!ENTITY Acirc   "&#194;" >
<!ENTITY Atilde  "&#195;" >
<!ENTITY Auml    "&#196;" >
<!ENTITY Aring   "&#197;" >
<!ENTITY AElig   "&#198;" >
<!ENTITY Ccedil  "&#199;" >
<!ENTITY Egrave  "&#200;" >
<!ENTITY Eacute  "&#201;" >
<!ENTITY Ecirc   "&#202;" >
<!ENTITY Euml    "&#203;" >
<!ENTITY Igrave  "&#204;" >
<!ENTITY Iacute  "&#205;" >
<!ENTITY Icirc   "&#206;" >
<!ENTITY Iuml    "&#207;" >
<!ENTITY ETH     "&#208;" >
<!ENTITY Ntilde  "&#209;" >
<!ENTITY Ograve  "&#210;" >
<!ENTITY Oacute  "&#211;" >
<!ENTITY Ocirc   "&#212;" >
<!ENTITY Otilde  "&#213;" >
<!ENTITY Ouml    "&#214;" >
<!ENTITY times   "&#215;" >
<!ENTITY Oslash  "&#216;" >
<!ENTITY Ugrave  "&#217;" >
<!ENTITY Uacute  "&#218;" >
<!ENTITY Ucirc   "&#219;" >
<!ENTITY Uuml    "&#220;" >
<!ENTITY Yacute  "&#221;" >
<!ENTITY THORN   "&#222;" >
<!ENTITY szlig   "&#223;" >
<!ENTITY agrave  "&#224;" >
<!ENTITY aacute  "&#225;" >
<!ENTITY acirc   "&#226;" >
<!ENTITY atilde  "&#227;" >
<!ENTITY auml    "&#228;" >
<!ENTITY aring   "&#229;" >
<!ENTITY aelig   "&#230;" >
<!ENTITY ccedil  "&#231;" >
<!ENTITY egrave  "&#232;" >
<!ENTITY eacute  "&#233;" >
<!ENTITY ecirc   "&#234;" >
<!ENTITY euml    "&#235;" >
<!ENTITY igrave  "&#236;" >
<!ENTITY iacute  "&#237;" >
<!ENTITY icirc   "&#238;" >
<!ENTITY iuml    "&#239;" >
<!ENTITY eth     "&#240;" >
<!ENTITY ntilde  "&#241;" >
<!ENTITY ograve  "&#242;" >
<!ENTITY oacute  "&#243;" >
<!ENTITY ocirc   "&#244;" >
<!ENTITY otilde  "&#245;" >
<!ENTITY ouml    "&#246;" >
<!ENTITY divide  "&#247;" >
<!ENTITY oslash  "&#248;" >
<!ENTITY ugrave  "&#249;" >
<!ENTITY uacute  "&#250;" >
<!ENTITY ucirc   "&#251;" >
<!ENTITY uuml    "&#252;" >
<!ENTITY yacute  "&#253;" >
<!ENTITY thorn   "&#254;" >
<!ENTITY yuml    "&#255;" >

]>

<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">
<xsl:output method="html" version="1.0"  indent="yes"/>

<!-- ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ -->
<xsl:template match="/">

	<html>
	<head>

		<title>
			<xsl:text disable-output-escaping="yes">#%lblQANav%# - #%lblFixDoc%# '</xsl:text>
			<xsl:value-of disable-output-escaping="yes" select="Fix/@Title"/>
			<xsl:text disable-output-escaping="yes">'</xsl:text>
		</title>

		<link rel="stylesheet" type="text/css" href="QNXSLStyle.css"/>
		<link href="favicon.ico" rel="shortcut icon"/>

		<xsl:apply-templates select="Fix/Script"/>
	</head>

	<body bgcolor="silver" class="work">
		<xsl:apply-templates select="Fix"/>
	</body>
	</html>

</xsl:template>

<!-- ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ -->
<xsl:template match="Script">
	<script type="text/javascript">
	<xsl:value-of disable-output-escaping="yes" select="text()"/>
	</script>
</xsl:template>

<!-- ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ -->
<xsl:template match="Fix">

	<h2 style="margin-left=6px;">#%lblFix%#</h2>

	<table width="95%">
		<tr>
			<td><b><xsl:value-of disable-output-escaping="yes" select="./@Title" /></b></td>
		</tr>
	</table>

	<table>
		<tr>
			<td width="120px"><b>#%lblTicket%#</b></td>
			<td><xsl:value-of select="./@Ticket" /></td>		
			<td width="120px"><b>#%lblUID%#</b></td>
			<td><xsl:value-of select="./@UID" /></td>
		</tr>
	</table>

	<table>
		<tr>
			<td width="120px"><b>#%lblAuthor%#</b></td>
			<td><xsl:value-of disable-output-escaping="yes" select="./@Assignd" /></td>
		</tr>
		<tr>
			<td width="120px"><b>#%lblDate%#</b></td>
			<td><xsl:value-of select="substring-before( ./@DateTime, 'T' )"/>&#160;<xsl:value-of select="substring-after( ./@DateTime, 'T' )"/></td>
		</tr>
		<tr>
			<td width="120px"><b>#%lblStatus%#</b></td>
			<td><xsl:apply-templates select="./@FixStat"/></td>
		</tr>
	</table>
	
	<xsl:if test="string(./@Lock)">
		<table><tr><td width="30"><img src="rsc/PadLock.jpg" alt="Locked"/></td></tr></table>
	</xsl:if>

	<table width="95%">
		<tr>
			<td width="120px"><b>#%lblAppl%#</b></td>
			<td><xsl:value-of disable-output-escaping="yes" select="./@Appl" /></td>
			<td width="80px"><b>#%lblRel%#</b></td>
			<td><xsl:value-of disable-output-escaping="yes" select="./@ProbRel" /></td>
		</tr>
		<tr>
			<td width="120px"><b>#%lblFctn%#</b></td>
			<td colspan="3"><xsl:value-of disable-output-escaping="yes" select="./@Fctn" /></td>
		</tr>
	</table>

	<table>
		<tr>
			<!-- td><b>#%lblPlndRel%#</b></td -->
			<td><b>#%lblDateFxd%#</b></td>
			<td><b>#%lblDateShpd%#</b></td>
			<td><b>#%lblShpdRel%#</b></td>
		</tr>
		<tr>
			<!-- td><xsl:value-of disable-output-escaping="yes" select="./@PlanRel" /></td -->
			<td><xsl:value-of select="substring-before( ./@DateTimeFix, 'T' )"/>&#160;<xsl:value-of select="substring-after( ./@DateTimeFix, 'T' )"/></td>
			<!-- td><xsl:value-of select="substring-before( ./@DateTimeShip, 'T' )"/>&#160;<xsl:value-of select="substring-after( ./@DateTimeShip, 'T' )"/></td -->
			<td><xsl:value-of disable-output-escaping="yes" select="./@DateTimeShip" /></td>
			<td><xsl:value-of disable-output-escaping="yes" select="./@ShipRel" /></td>
		</tr>
	</table>

	<table>
		<tr>
			<td><b>#%lblFixTst%# #%lblDate%#</b></td>
			<td><b>#%lblSys%#</b></td>
		</tr>	
		<tr>
			<td><xsl:value-of disable-output-escaping="yes" select="./@FixTstDate" /></td>
			<td><xsl:value-of disable-output-escaping="yes" select="./@FixTstSys" /></td>
		</tr>
	</table>

	<xsl:if test="RefProbRep">

		<xsl:call-template name="RefProbRep"/>
	</xsl:if>

	<!-- xsl:apply-templates select="./RefProbRep"/ -->

	<table width="95%">
		<tr><td><b>#%lblFixDesc%#</b></td></tr>
		<tr><td>
			<xsl:call-template name="br-replace">
				<xsl:with-param name="word" select="./Desc"/>
			</xsl:call-template>
		</td></tr>
	</table>


	<table width="95%">
		<tr><td><b>#%lblTestReq%#</b></td></tr>
		<tr><td>
			<xsl:call-template name="br-replace">
				<xsl:with-param name="word" select="./TestReq"/>
			</xsl:call-template>
		</td></tr>
	</table>


	<table width="95%">
		<tr><td><b>#%lblFixImp%#</b></td></tr>
		<tr><td>
			<xsl:call-template name="br-replace">
				<xsl:with-param name="word" select="./FixImp"/>
			</xsl:call-template>
		</td></tr>
	</table>
	
	<h4 style="margin-left=6px;">#%lblFixLst%#</h4>

	<xsl:apply-templates select="./FixLst"/>

	<xsl:if test="ProcLog">

		<h4 style="margin-left=6px;">#%lblProcLog%#</h4>
		<xsl:apply-templates select="./ProcLog"/>
	</xsl:if>

	<!-- SysConfigRef*, AddInfo* -->

</xsl:template>

<!-- ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ -->
<xsl:template match="@FixStat">

	<xsl:choose > 
		<xsl:when test = ". = 'as'" > 
			<xsl:text>#%valStat_as%#</xsl:text> 
		</xsl:when> 
		<xsl:when test = ". = 'fd'" > 
			<xsl:text>#%valStat_fd%#</xsl:text> 
		</xsl:when> 
		<xsl:when test = ". = 'fx'" > 
			<xsl:text>#%valStat_fx%#</xsl:text> 
		</xsl:when> 
		<xsl:when test = ". = 'wf'" > 
			<xsl:text>#%valStat_wf%#</xsl:text> 
		</xsl:when>
		<xsl:when test = ". = 'ct'" > 
			<xsl:text>#%valStat_ct%#</xsl:text> 
		</xsl:when>
		<xsl:when test = ". = 'tf'" > 
			<xsl:text>#%valStat_tf%#</xsl:text> 
		</xsl:when>
		<xsl:when test = ". = 'rr'" > 
			<xsl:text>#%valStat_rr%#</xsl:text> 
		</xsl:when>
		<xsl:when test = ". = 'rs'" > 
			<xsl:text>#%valStat_rs%#</xsl:text> 
		</xsl:when>
		<xsl:when test = ". = 'rt'" > 
			<xsl:text>#%valStat_rt%#</xsl:text> 
		</xsl:when>
		<xsl:when test = ". = 'rv'" > 
			<xsl:text>#%valStat_rv%#</xsl:text> 
		</xsl:when>
		<xsl:when test = ". = 'sh'" > 
			<xsl:text>#%valStat_sh%#</xsl:text> 
		</xsl:when> 
		<xsl:when test = ". = 'cl'" > 
			<xsl:text>#%valStat_cl%#</xsl:text> 
		</xsl:when>  
		<xsl:otherwise> 
			<xsl:value-of disable-output-escaping="yes" select="." />
		</xsl:otherwise> 
	</xsl:choose>  

</xsl:template>

<!-- ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ -->
<xsl:template name="RefProbRep">

	<table width="95%">
		<tr>
			<td width="140px"><b>#%lblProbRep%#</b></td>
		</tr>
		<xsl:for-each select="RefProbRep">
			<tr>
				<td>
					<xsl:if test="string(./@RefUID)">
						<a href="VTRFr.jsp?QNA=ViewTR&amp;UID={@RefUID}" target="_parent">
							<xsl:value-of disable-output-escaping="yes" select="./@Title"/>
						</a>			
					</xsl:if>
				</td>		
			</tr>
		</xsl:for-each>
	</table>

</xsl:template>

<!-- ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ -->
<xsl:template match="FixLst">

	<table>
		<tr>
			<td><b>#%lblDate%#</b></td>
			<td><b>#%lblAuthor%#</b></td>			
			<td><b>#%lblPath%#</b></td>		
			<td><b>#%lblSrcFile%#</b></td>
			<td><b>#%lblBranch%#</b></td>			
			<td><b>#%lblVer%#</b></td>			
			<td><b>#%lblSection%#</b></td>
			<!-- td><b>#%lblLbl%#</b></td -->
			<!-- td><b>#%lblDB%#</b></td -->
			<td><b>#%lblCmnt%#</b></td>
		</tr>
		<xsl:for-each select="./FixEntry">
			<tr>
				<xsl:choose>

					<xsl:when test="contains( ./@DateTime, 'T' )">

						<td><xsl:value-of select="substring-before( ./@DateTime, 'T' )"/>&#160;<xsl:value-of select="substring-after( ./@DateTime, 'T' )"/></td>
					</xsl:when>

					<xsl:otherwise>

						<td><xsl:value-of disable-output-escaping="yes" select="./@DateTime"/></td>
					</xsl:otherwise>
				</xsl:choose>
				
				<td><xsl:value-of disable-output-escaping="yes" select="./@Author"/></td>
				<td><xsl:value-of disable-output-escaping="yes" select="./@Path"/></td>				
				<td><xsl:value-of disable-output-escaping="yes" select="./@Name"/></td>	
				<td><xsl:value-of disable-output-escaping="yes" select="./@Branch"/></td>	
				<td><xsl:value-of disable-output-escaping="yes" select="./@Rel"/></td>
				<td><xsl:value-of disable-output-escaping="yes" select="./@Section"/></td>
				<!-- td><xsl:value-of disable-output-escaping="yes" select="./@Label"/></td -->
				<!-- td><xsl:value-of disable-output-escaping="yes" select="./@SrcSrv"/></td -->
				<td><xsl:value-of disable-output-escaping="yes" select="./@Cmnt"/></td>
			</tr>
		</xsl:for-each>
	</table>

</xsl:template>


<!-- ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ -->
<xsl:template match="LogEntry">

	<table width="95%">
		<tr><td><xsl:value-of disable-output-escaping="yes" select="./@Title"/></td></tr>
		<tr><td>#%lblAuthor%#: <xsl:value-of disable-output-escaping="yes" select="./@Author"/> #%lblDate%#: <xsl:value-of select="substring-before( ./@DateTime, 'T' )"/>&#160;<xsl:value-of select="substring-after( ./@DateTime, 'T' )"/></td></tr>
		<tr><td>
			<p>
				<xsl:call-template name="br-replace">
					<xsl:with-param name="word" select="."/>
				</xsl:call-template>
			</p>
		</td></tr>
	</table>

</xsl:template>

<!-- ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ -->
<xsl:template match="ProcLog">

	<table width="95%">
		<tr><td class="DT"><xsl:value-of select="substring-before( ./@DateTime, 'T' )"/>&#160;<xsl:value-of select="substring-after( ./@DateTime, 'T' )"/></td></tr>
		<tr><td>
			<p><xsl:value-of disable-output-escaping="yes" select="."/></p>
		</td></tr>
	</table>

</xsl:template>

<!-- ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ -->
<xsl:template name="br-replace">

	<xsl:param name="word"/>

	<!-- </xsl:text> on next line on purpose to get newline -->
  <xsl:variable name="cr"><xsl:text>
</xsl:text></xsl:variable>
	<xsl:choose>

		<xsl:when test="contains($word,$cr)">

			<xsl:value-of disable-output-escaping="yes" select="substring-before($word,$cr)"/>
			<br/>
			<xsl:call-template name="br-replace">

				<xsl:with-param name="word">

					<xsl:value-of select="substring-after($word,$cr)"/>
			  </xsl:with-param>
			</xsl:call-template>
		</xsl:when>

		<xsl:otherwise>

			<xsl:value-of disable-output-escaping="yes" select="$word"/>
		</xsl:otherwise>
	</xsl:choose>
</xsl:template>

</xsl:stylesheet>
 