<?xml version='1.0'?>
<!-- Stylesheet for a test case -->

<!DOCTYPE stylesheet [

<!ENTITY nbsp    "&#160;" >
<!ENTITY iexcl   "&#161;" >
<!ENTITY cent    "&#162;" >
<!ENTITY pound   "&#163;" >
<!ENTITY curren  "&#164;" >
<!ENTITY yen     "&#165;" >
<!ENTITY brvbar  "&#166;" >
<!ENTITY sect    "&#167;" >
<!ENTITY uml     "&#168;" >
<!ENTITY copy    "&#169;" >
<!ENTITY ordf    "&#170;" >
<!ENTITY laquo   "&#171;" >
<!ENTITY not     "&#172;" >
<!ENTITY shy     "&#173;" >
<!ENTITY reg     "&#174;" >
<!ENTITY macr    "&#175;" >
<!ENTITY deg     "&#176;" >
<!ENTITY plusmn  "&#177;" >
<!ENTITY sup2    "&#178;" >
<!ENTITY sup3    "&#179;" >
<!ENTITY acute   "&#180;" >
<!ENTITY micro   "&#181;" >
<!ENTITY para    "&#182;" >
<!ENTITY middot  "&#183;" >
<!ENTITY cedil   "&#184;" >
<!ENTITY sup1    "&#185;" >
<!ENTITY ordm    "&#186;" >
<!ENTITY raquo   "&#187;" >
<!ENTITY frac14  "&#188;" >
<!ENTITY frac12  "&#189;" >
<!ENTITY frac34  "&#190;" >
<!ENTITY iquest  "&#191;" >
<!ENTITY Agrave  "&#192;" >
<!ENTITY Aacute  "&#193;" >
<!ENTITY Acirc   "&#194;" >
<!ENTITY Atilde  "&#195;" >
<!ENTITY Auml    "&#196;" >
<!ENTITY Aring   "&#197;" >
<!ENTITY AElig   "&#198;" >
<!ENTITY Ccedil  "&#199;" >
<!ENTITY Egrave  "&#200;" >
<!ENTITY Eacute  "&#201;" >
<!ENTITY Ecirc   "&#202;" >
<!ENTITY Euml    "&#203;" >
<!ENTITY Igrave  "&#204;" >
<!ENTITY Iacute  "&#205;" >
<!ENTITY Icirc   "&#206;" >
<!ENTITY Iuml    "&#207;" >
<!ENTITY ETH     "&#208;" >
<!ENTITY Ntilde  "&#209;" >
<!ENTITY Ograve  "&#210;" >
<!ENTITY Oacute  "&#211;" >
<!ENTITY Ocirc   "&#212;" >
<!ENTITY Otilde  "&#213;" >
<!ENTITY Ouml    "&#214;" >
<!ENTITY times   "&#215;" >
<!ENTITY Oslash  "&#216;" >
<!ENTITY Ugrave  "&#217;" >
<!ENTITY Uacute  "&#218;" >
<!ENTITY Ucirc   "&#219;" >
<!ENTITY Uuml    "&#220;" >
<!ENTITY Yacute  "&#221;" >
<!ENTITY THORN   "&#222;" >
<!ENTITY szlig   "&#223;" >
<!ENTITY agrave  "&#224;" >
<!ENTITY aacute  "&#225;" >
<!ENTITY acirc   "&#226;" >
<!ENTITY atilde  "&#227;" >
<!ENTITY auml    "&#228;" >
<!ENTITY aring   "&#229;" >
<!ENTITY aelig   "&#230;" >
<!ENTITY ccedil  "&#231;" >
<!ENTITY egrave  "&#232;" >
<!ENTITY eacute  "&#233;" >
<!ENTITY ecirc   "&#234;" >
<!ENTITY euml    "&#235;" >
<!ENTITY igrave  "&#236;" >
<!ENTITY iacute  "&#237;" >
<!ENTITY icirc   "&#238;" >
<!ENTITY iuml    "&#239;" >
<!ENTITY eth     "&#240;" >
<!ENTITY ntilde  "&#241;" >
<!ENTITY ograve  "&#242;" >
<!ENTITY oacute  "&#243;" >
<!ENTITY ocirc   "&#244;" >
<!ENTITY otilde  "&#245;" >
<!ENTITY ouml    "&#246;" >
<!ENTITY divide  "&#247;" >
<!ENTITY oslash  "&#248;" >
<!ENTITY ugrave  "&#249;" >
<!ENTITY uacute  "&#250;" >
<!ENTITY ucirc   "&#251;" >
<!ENTITY uuml    "&#252;" >
<!ENTITY yacute  "&#253;" >
<!ENTITY thorn   "&#254;" >
<!ENTITY yuml    "&#255;" >

]>

<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">
<xsl:output method="html" version="1.0"  indent="yes"/>

<!-- ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ -->
<xsl:template match="/">

	<html>
	<head>

		<title>
			<xsl:text disable-output-escaping="yes">#%lblQANav%# - #%lblTC%# '</xsl:text>
			<xsl:value-of disable-output-escaping="yes" select="TestCase/@Title"/>
			<xsl:text disable-output-escaping="yes">'</xsl:text>
		</title>

		<link rel="stylesheet" type="text/css" href="QNXSLStyle.css"/>
		<link href="favicon.ico" rel="shortcut icon"/>

		<xsl:apply-templates select="TestCase/Script"/>
	</head>
	<body bgcolor="silver" class="work">
		<xsl:apply-templates select="TestCase"/>
	</body>
	</html>

</xsl:template>

<!-- ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ -->
<xsl:template match="Script">
	<script type="text/javascript">
	<xsl:value-of disable-output-escaping="yes" select="text()"/>
	</script>
</xsl:template>

<!-- ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ -->
<xsl:template match="TestCase">

	<h2 style="margin-left=6px;">#%lblTC%#</h2>

	<table width="95%">
		<tr>
			<td><b><xsl:value-of disable-output-escaping="yes" select="./@Title" /></b></td>
		</tr>
	</table>
	
	<table width="95%">
		<tr>
			<td width="120px"><b>UID</b></td>
			<td colspan="3"><xsl:value-of disable-output-escaping="yes" select="./@UID" /></td>
		</tr>
		<tr>
			<td width="120px"><b>#%lblSection%#</b></td>
			<td colspan="3"><xsl:value-of disable-output-escaping="yes" select="./@Section" /></td>
		</tr>
		<tr>
			<td width="120px"><b>#%lblAppl%#</b></td>
			<td><xsl:value-of disable-output-escaping="yes" select="./@Appl" /></td>
			<td width="80px"><b>#%lblRel%#</b></td>
			<td><xsl:value-of disable-output-escaping="yes" select="./@SoftRel" /></td>
		</tr>
		<tr>
			<td width="120px"><b>#%lblFctn%#</b></td>
			<td colspan="3"><xsl:value-of disable-output-escaping="yes" select="./@Fctn" /></td>
		</tr>
	</table>

<!-- 		UID				"Get Link" button -->

	<table>
		<tr>
			<td width="120px"><b>#%lblAuthor%#</b></td>
			<td ><xsl:value-of disable-output-escaping="yes" select="./@Author" /></td>
		</tr>
		<tr>
			<td width="120px"><b>#%lblVer%#</b></td>
			<td><xsl:apply-templates select="./@Ver"/></td>
		</tr>
		<tr>
			<td width="120px"><b>#%lblDate%#</b></td>
			<td><xsl:value-of select="substring-before( ./@DateTime, 'T' )"/>&#160;<xsl:value-of select="substring-after( ./@DateTime, 'T' )"/></td>
		</tr>
		<tr>
			<td width="120px"><b>#%lblTCType%#</b></td>
			<td><xsl:apply-templates select="./@TCType"/></td>
		</tr>
		<tr>
			<td width="120px"><b>#%lblPrio%#</b></td>
			<td><xsl:apply-templates select="./@Prio"/></td>
		</tr>
		<tr>
			<td width="120px"><b>#%lblExpDur%#</b></td>
			<td><xsl:apply-templates select="./@ExpDur"/></td>
		</tr>
	</table>

	<xsl:if test="string(./@Lock)">
		<table><tr><td width="30"><img src="rsc/PadLock.jpg" alt="Locked"/></td></tr></table>
	</xsl:if>

	<xsl:if test="RefTC">

		<xsl:call-template name="RefTC"/>
	</xsl:if>

	<xsl:if test="ReqmntSrc">

		<xsl:call-template name="ReqmntSrc"/>
	</xsl:if>

	<xsl:if test="TSysConfigRef">

		<xsl:call-template name="TSysConfigRef"/>
	</xsl:if>

	<table width="95%">
		<tr><td><b>#%lblDesc%#</b></td></tr>
		<tr><td>
			<xsl:call-template name="br-replace">
				<xsl:with-param name="word" select="./Desc"/>
			</xsl:call-template>
		</td></tr>
	</table>

	<table width="95%">
		<tr><td><b>#%lblTestProc%#</b></td></tr>
		<tr><td>
			<xsl:call-template name="br-replace">
				<xsl:with-param name="word" select="./TestProc"/>
			</xsl:call-template></td></tr>
	</table>

	<xsl:if test="TestProcData">

		<xsl:call-template name="TestProcData"/>
	</xsl:if>

	<table width="95%">
		<tr><td><b>#%lblExpResult%#</b></td></tr>
		<tr><td>
			<xsl:call-template name="br-replace">
				<xsl:with-param name="word" select="./ExpResult"/>
			</xsl:call-template>
		</td></tr>
	</table>

	<xsl:if test="TestRsltData">

		<xsl:call-template name="TestRsltData"/>
	</xsl:if>

	<xsl:if test="ProcLog">

		<h4 style="margin-left=6px;">#%lblProcLog%#</h4>
		<xsl:apply-templates select="./ProcLog"/>
	</xsl:if>

</xsl:template>

<!-- ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ -->
<xsl:template match="@TCType">

	<xsl:choose > 
		<xsl:when test = ". = 'ac'" > 
			<xsl:text>#%lblAccptTst%#</xsl:text> 
		</xsl:when> 
		<xsl:when test = ". = 'co'" > 
			<xsl:text>#%lblConfigTst%#</xsl:text> 
		</xsl:when> 
		<xsl:when test = ". = 'do'" > 
			<xsl:text>#%lblDocTst%#</xsl:text> 
		</xsl:when> 
		<xsl:when test = ". = 'fi'" > 
			<xsl:text>#%lblFixTst%#</xsl:text> 
		</xsl:when>
		<xsl:when test = ". = 'fu'" > 
			<xsl:text>#%lblFctnTst%#</xsl:text> 
		</xsl:when>
		<xsl:when test = ". = 'in'" > 
			<xsl:text>#%lblIntgrTst%#</xsl:text> 
		</xsl:when>
		<xsl:when test = ". = 'lo'" > 
			<xsl:text>#%lblLoadTst%#</xsl:text> 
		</xsl:when>
		<xsl:when test = ". = 'mo'" > 
			<xsl:text>#%lblModuleTst%#</xsl:text> 
		</xsl:when> 
		<xsl:when test = ". = 'pe'" > 
			<xsl:text>#%lblPerfTst%#</xsl:text> 
		</xsl:when>
		<xsl:when test = ". = 'se'" > 
			<xsl:text>#%lblSecurityTst%#</xsl:text> 
		</xsl:when> 
		<xsl:when test = ". = 'un'" > 
			<xsl:text>#%lblUnitTst%#</xsl:text> 
		</xsl:when> 
		<xsl:when test = ". = 'us'" > 
			<xsl:text>#%lblUseTst%#</xsl:text> 
		</xsl:when>
		<xsl:when test = ". = 'vo'" > 
			<xsl:text>#%lblVolTst%#</xsl:text> 
		</xsl:when>
		<xsl:when test = ". = 'prep'" > 
			<xsl:text>#%lblTstPrepStep%#</xsl:text> 
		</xsl:when>
		<xsl:otherwise> 
			<xsl:value-of disable-output-escaping="yes" select="." />
		</xsl:otherwise> 
	</xsl:choose> 

</xsl:template>

<!-- ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ -->
<xsl:template match="@Prio">

	<xsl:choose > 
		<xsl:when test = ". = '1'" > 
			<xsl:text>#%lblHigh%#</xsl:text> 
		</xsl:when>
		<xsl:when test = ". = '2'" > 
			<xsl:text>#%lblMedium%#</xsl:text> 
		</xsl:when>
		<xsl:when test = ". = '3'" > 
			<xsl:text>#%lblLow%#</xsl:text> 
		</xsl:when>
		<xsl:otherwise> 
			<xsl:value-of disable-output-escaping="yes" select="." />
		</xsl:otherwise> 
	</xsl:choose> 

</xsl:template>		


<!-- ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ -->
<xsl:template name="RefTC">

	<table width="95%">
		<tr><td><b>#%lblPrecTC%#</b></td></tr>
		<xsl:for-each select="./RefTC">
			<tr><td>
				<xsl:if test="string(./@RefUID)">
					<a href="VQANavDoc?QNA=ViewTC&amp;UID={@RefUID}">
						<xsl:value-of disable-output-escaping="yes" select="./@Title"/>
					</a>
				</xsl:if>
			</td></tr>
		</xsl:for-each>
	</table>

</xsl:template>

<!-- ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ -->
<xsl:template name="ReqmntSrc">

	<table width="95%">
		<tr><td><b>#%lblReqs%#</b></td></tr>
		<xsl:for-each select="./ReqmntSrc">
			<tr><td>
				<xsl:if test="string(./@RefUID)">
					<a href="VQANavDoc?QNA=ViewTC&amp;UID={@RefUID}">
						<xsl:value-of disable-output-escaping="yes" select="./@Title"/>
					</a>
				</xsl:if>
				<xsl:if test="string(./@Location)">
					<p><xsl:value-of disable-output-escaping="yes" select="./@Location"/></p>
				</xsl:if>
			</td></tr>
		</xsl:for-each>
	</table>

</xsl:template>

<!-- ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ -->
<xsl:template name="TSysConfigRef">

	<table width="95%">
		<tr><td><b>#%lblTSysConfig%#</b></td></tr>
		<xsl:for-each select="./TSysConfigRef">
			<tr><td>
				<xsl:choose>
					<xsl:when test="string(./@RefUID)">
						<a href="VQANavDoc?QNA=ViewTSysConfC&amp;UID={@RefUID}">
							<xsl:value-of disable-output-escaping="yes" select="./@Title"/>
						</a>
					</xsl:when>
					<xsl:otherwise>
						<xsl:value-of disable-output-escaping="yes" select="./@Title"/>
					</xsl:otherwise>
				</xsl:choose>
			</td></tr>
		</xsl:for-each>
	</table>

</xsl:template>

<!-- ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ -->
<xsl:template name="TestProcData">

	<table width="95%">
		<tr><td><b>#%lblTestProcFiles%#</b></td></tr>
		<xsl:for-each select="./TestProcData">
			<tr><td>
				<table width="98%">
					<tr>
						<td>
							<xsl:choose>
								<xsl:when test="string(./@BlobUID)">
									<a href="QANDLDoc?UID={@BlobUID}">
										<xsl:value-of disable-output-escaping="yes" select="./@Title"/>
									</a>
								</xsl:when>
								<xsl:otherwise>
									<xsl:value-of disable-output-escaping="yes" select="./@Title"/>
								</xsl:otherwise>
							</xsl:choose>
						</td>
						<td>
							<xsl:value-of select="substring-before( ./@DateTime, 'T' )"/>&#160;<xsl:value-of select="substring-after( ./@DateTime, 'T' )"/>
						</td>
						<td>
							<xsl:value-of disable-output-escaping="yes" select="./@ContentType"/>
						</td>
					</tr>
					<tr>
						<td colspan="3">
							<xsl:value-of disable-output-escaping="yes" select="./@FileName"/>
						</td>
					</tr>
				</table>
			</td></tr>
		</xsl:for-each>
	</table>

</xsl:template>


<!-- ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ -->
<xsl:template name="TestRsltData">

	<table width="95%">
		<tr><td><b>#%lblTestResFiles%#</b></td></tr>
		<xsl:for-each select="./TestRsltData">
			<tr><td>
				<table width="98%">
					<tr>
						<td>
							<xsl:choose>
								<xsl:when test="string(./@BlobUID)">
									<a href="QANDLDoc?UID={@BlobUID}">
										<xsl:value-of disable-output-escaping="yes" select="./@Title"/>
									</a>
								</xsl:when>
								<xsl:otherwise>
									<xsl:value-of disable-output-escaping="yes" select="./@Title"/>
								</xsl:otherwise>
							</xsl:choose>
						</td>
						<td>
							<xsl:value-of select="substring-before( ./@DateTime, 'T' )"/>&#160;<xsl:value-of select="substring-after( ./@DateTime, 'T' )"/>
						</td>
						<td>
							<xsl:value-of disable-output-escaping="yes" select="./@ContentType"/>
						</td>
					</tr>
					<tr>
						<td colspan="3">
							<xsl:value-of disable-output-escaping="yes" select="./@FileName"/>
						</td>
					</tr>
				</table>
			</td></tr>
		</xsl:for-each>
	</table>

</xsl:template>

<!-- ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ -->
<xsl:template match="ProcLog">

	<table width="95%">
		<tr><td class="DT"><xsl:value-of select="substring-before( ./@DateTime, 'T' )"/>&#160;<xsl:value-of select="substring-after( ./@DateTime, 'T' )"/></td></tr>
		<tr><td>
			<p><xsl:value-of disable-output-escaping="yes" select="."/></p>
		</td></tr>
	</table>

</xsl:template>

<!-- ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ -->
<xsl:template name="br-replace">

	<xsl:param name="word"/>

	<!-- </xsl:text> on next line on purpose to get newline -->
  <xsl:variable name="cr"><xsl:text>
</xsl:text></xsl:variable>
	<xsl:choose>

		<xsl:when test="contains($word,$cr)">

			<xsl:value-of disable-output-escaping="yes" select="substring-before($word,$cr)"/>
			<br/>
			<xsl:call-template name="br-replace">

				<xsl:with-param name="word">

					<xsl:value-of select="substring-after($word,$cr)"/>
			  </xsl:with-param>
			</xsl:call-template>
		</xsl:when>

		<xsl:otherwise>

			<xsl:value-of disable-output-escaping="yes" select="$word"/>
		</xsl:otherwise>
	</xsl:choose>
</xsl:template>

</xsl:stylesheet>
